using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;

using System.Globalization;
//using System.Math;
namespace Theremino_HAL
{


	// ==================================================================================================
	//   CLASS PIN
	// ==================================================================================================
	class Pin
	{

		internal enum Directions : int
		{
			Unused = 0,
			HostToMaster = 1,
			MasterToHost = 2
		}


		internal enum PinTypes : int
		{
			UNUSED = 0,

			DIG_OUT = 1,
			PWM_8 = 2,
			PWM_16 = 3,
			SERVO_8 = 4,
			SERVO_16 = 5,

			DIG_IN = 129,
			DIG_IN_PU = 130,

			ADC_8 = 131,
			ADC_16 = 132,
			CAP_8 = 133,
			CAP_16 = 134,
			RES_8 = 135,
			RES_16 = 136,

			COUNTER = 140,
			COUNTER_PU = 141,

			FAST_COUNTER = 142,
			FAST_COUNTER_PU = 143,

			PERIOD = 144,
			PERIOD_PU = 145,

			USOUND_SENSOR = 150,

			CAP_SENSOR = 160,

			I2C_SDA = 170,
			I2C_SCL = 171,

			MCA_8_BYTES = 180,
			MCA_16_BYTES = 181,
			MCA_32_BYTES = 182,

			SNIFFER = 190
		}


		public static PinTypes StringToPinType(string PinTypeString)
		{
			switch (Strings.UCase(PinTypeString.Trim())) {
				case "UNUSED": return PinTypes.UNUSED;

				case "DIG_OUT": return PinTypes.DIG_OUT;
				case "PWM_8": return PinTypes.PWM_8;
				case "PWM_16": return PinTypes.PWM_16;
				case "SERVO_8": return PinTypes.SERVO_8;
				case "SERVO_16": return PinTypes.SERVO_16;

				case "DIG_IN": return PinTypes.DIG_IN;
				case "DIG_IN_PU": return PinTypes.DIG_IN_PU;

				case "ADC_8": return PinTypes.ADC_8;
				case "ADC_16": return PinTypes.ADC_16;
				case "CAP_8": return PinTypes.CAP_8;
				case "CAP_16": return PinTypes.CAP_16;
				case "RES_8": return PinTypes.RES_8;
				case "RES_16":return PinTypes.RES_16;

				case "COUNTER": return PinTypes.COUNTER;
				case "COUNTER_PU": return PinTypes.COUNTER_PU;

				case "FAST_COUNTER": return PinTypes.FAST_COUNTER;
				case "FAST_COUNTER_PU": return PinTypes.FAST_COUNTER_PU;
				
                case "PERIOD": return PinTypes.PERIOD;
				case "PERIOD_PU": return PinTypes.PERIOD_PU;

				case "USOUND_SENSOR": return PinTypes.USOUND_SENSOR;
				
                case "CAP_SENSOR": return PinTypes.CAP_SENSOR;
				
                case "I2C_SDA": return PinTypes.I2C_SDA;
				case "I2C_SCL": return PinTypes.I2C_SCL;
				
                case "MCA_8_BYTES": return PinTypes.MCA_8_BYTES;
				case "MCA_16_BYTES": return PinTypes.MCA_16_BYTES;
				case "MCA_32_BYTES": return PinTypes.MCA_32_BYTES;
				
                case "SNIFFER": return PinTypes.SNIFFER;
				
                //Case "UART_TX" : Return PinTypes.UART_TX
				//Case "UART_RX" : Return PinTypes.UART_RX
				//Case "UART_CTS" : Return PinTypes.UART_CTS
				//Case "UART_RTS" : Return PinTypes.UART_RTS
				//Case "VREF_POS" : Return PinTypes.VREF_POS
				//Case "VREF_NEG" : Return PinTypes.VREF_NEG
			}
            return PinTypes.UNUSED;
		}

		public static string PinTypeToString(PinTypes pintype)
		{
			string s = "";
			switch (pintype) {
				case PinTypes.UNUSED:
					s = "UNUSED";

					break;
				case PinTypes.DIG_OUT:
					s = "DIG_OUT";
					break;
				case PinTypes.PWM_8:
					s = "PWM_8";
					break;
				case PinTypes.PWM_16:
					s = "PWM_16";
					break;
				case PinTypes.SERVO_8:
					s = "SERVO_8";
					break;
				case PinTypes.SERVO_16:
					s = "SERVO_16";

					break;
				case PinTypes.DIG_IN:
					s = "DIG_IN";
					break;
				case PinTypes.DIG_IN_PU:
					s = "DIG_IN_PU";

					break;
				case PinTypes.ADC_8:
					s = "ADC_8";
					break;
				case PinTypes.ADC_16:
					s = "ADC_16";
					break;
				case PinTypes.CAP_8:
					s = "CAP_8";
					break;
				case PinTypes.CAP_16:
					s = "CAP_16";
					break;
				case PinTypes.RES_8:
					s = "RES_8";
					break;
				case PinTypes.RES_16:
					s = "RES_16";

					break;
				case PinTypes.COUNTER:
					s = "COUNTER";
					break;
				case PinTypes.COUNTER_PU:
					s = "COUNTER_PU";

					break;
				case PinTypes.FAST_COUNTER:
					s = "FAST_COUNTER";
					break;
				case PinTypes.FAST_COUNTER_PU:
					s = "FAST_COUNTER_PU";

					break;
				case PinTypes.PERIOD:
					s = "PERIOD";
					break;
				case PinTypes.PERIOD_PU:
					s = "PERIOD_PU";

					break;
				case PinTypes.USOUND_SENSOR:
					s = "USOUND_SENSOR";

					break;
				case PinTypes.CAP_SENSOR:
					s = "CAP_SENSOR";

					break;
				case PinTypes.I2C_SDA:
					s = "I2C_SDA";
					break;
				case PinTypes.I2C_SCL:
					s = "I2C_SCL";

					break;
				case PinTypes.MCA_8_BYTES:
					s = "MCA_8_BYTES";
					break;
				case PinTypes.MCA_16_BYTES:
					s = "MCA_16_BYTES";
					break;
				case PinTypes.MCA_32_BYTES:
					s = "MCA_32_BYTES";

					break;
				case PinTypes.SNIFFER:
					s = "SNIFFER";

					break;
				//Case PinTypes.UART_TX : s = "UART_TX"
				//Case PinTypes.UART_RX : s = "UART_RX"
				//Case PinTypes.UART_CTS : s = "UART_CTS"
				//Case PinTypes.UART_RTS : s = "UART_RTS"
				//Case PinTypes.VREF_POS : s = "VREF_POS"
				//Case PinTypes.VREF_NEG : s = "VREF_NEG"
			}

            return Module_Utils.CamelCaseString(s);
		}




		internal Int32 MasterId;
		internal Int32 SlaveId;
		internal Int32 PinId;
		private PinTypes PinType;
		internal Directions Direction;
		// ------------------------------------------- slot 0 to 999 starting from the pin near to master
		internal Int32 Slot;
		// ------------------------------------------- byte index in the USB buffer ( HostToMaster or MasterToHost )
		internal Int32 UsbByteIndex;
		// ------------------------------------------- bytes used by this pin in the USB(Host-Master) communications
		internal Int32 UsbBytesCount;
		// ------------------------------------------- bytes used by this pin in the COM(Master-Slave) communications

		internal Int32 ComBytesCount;
		// ------------------------------------------- all pins
		internal UInt32 Value_RawInteger_Old;
		internal UInt32 Value_RawInteger_Zero;
		internal UInt32 Value_RawInteger;
		internal UInt32 Value_RawInteger_Max;
		internal UInt32 Value_RawInteger_Min;
		internal float Value_RawSmooted;
		internal float Value;
		internal float Value_Max;
		internal float Value_Min;
		internal float Value_Parking;
		internal float Value_Normalized_New;
		internal float Value_Normalized = 0;
		internal Int32 ResponseSpeed;
		internal Int32 RepTime;
		// ------------------------------------------ Servo and Pwm specific
		internal float MaxTime;
		internal float MinTime;
		internal bool LogResponse;
		// ------------------------------------------ Counter and Period specific
		internal bool ConvertToFreq;
		internal float MaxFreq;
		internal float MinFreq;
		// ------------------------------------------ Usound_sensor and Cap_sensor specific
        internal bool RemoveErrors;
		internal float Dist_mm;
		internal float MaxDist_mm;
		internal float MinDist_mm;
		// ------------------------------------------ Touch specific
		internal float MinVariation;
		internal float ProportionalArea;
		internal float MeanValue;
        private float Velocity = 0;
        private float oldDelta1;
        private float oldDelta2;
        private float oldDelta3;

		// ------------------------------------------ Cap_sensor specific
		internal Int32 ErrorCounter;
		internal Int32 TimerDivision;
		internal Int32 TimerFrequencyKhz;
		internal float Inductor_uh;
		internal float Area_cmq;
		//
		internal float Millisec;
		internal float Freq;
		//
		internal double Cap_serial;
		internal float Cap_total;
		internal float Cap_zero;

		internal float Cap_input;
		// ------------------------------------------ Sniffer specific
		internal bool SnifferLogEnabled;
		private Int32 nNewSniffedBytes;
		private Int32 nSniffedBytes;
		private Int32 SnifferStatus;
		private Int32[] SniffedBytes = new Int32[1001];
		private Int32[] SniffedFlags = new Int32[1001];

		private object SnifferLogLock = new object();


		internal Pin(PinTypes _pintype, Int32 _masterid, Int32 _slaveid, Int32 _pinid)
		{
			MasterId = _masterid;
			SlaveId = _slaveid;
			PinId = _pinid;
			RepTime = 1;
			SetPinType(_pintype);
		}

		internal PinTypes GetPinType()
		{
			return PinType;
		}

		internal string GetDirectionString()
		{
			switch (Direction) {
				case Pin.Directions.HostToMaster:
					return "set";
				case Pin.Directions.MasterToHost:
					return "get";
				default:
					return "";
			}
		}


		// ==================================================================================================
		//   DEFAULTS
		// ==================================================================================================

		internal void SetPinType(PinTypes _pintype)
		{
			if (PinType == _pintype) return; 
			PinType = _pintype;
			//
			ResponseSpeed = 100;
			// --------------------------------------------------------- defaults
			switch (PinType) {

				// ----------------------------------------------------- outputs
				case PinTypes.DIG_OUT:
                    Value_Parking = MemoryMappedFiles.NAN_Sleep;
					Value_Max = 1000;
					Value_Min = 0;
					UsbBytesCount = 1;
					ComBytesCount = 1;
					break;
				case PinTypes.PWM_8:
					Value_Parking = 0;
					Value_Max = 1000;
					Value_Min = 0;
					MaxTime = 4000;
					MinTime = 0;
					LogResponse = false;
					UsbBytesCount = 1;
					ComBytesCount = 1;
					break;
				case PinTypes.PWM_16:
					Value_Parking = 0;
					Value_Max = 1000;
					Value_Min = 0;
					MaxTime = 4000;
					MinTime = 0;
					LogResponse = false;
					UsbBytesCount = 2;
					ComBytesCount = 2;
					break;
				case PinTypes.SERVO_8:
                    Value_Parking = MemoryMappedFiles.NAN_Sleep;
					Value_Max = 1000;
					Value_Min = 0;
					MaxTime = 2500;
					MinTime = 500;
					Value_Parking = 0;
					UsbBytesCount = 1;
					ComBytesCount = 1;
					break;
				case PinTypes.SERVO_16:
                    Value_Parking = MemoryMappedFiles.NAN_Sleep;
					Value_Max = 1000;
					Value_Min = 0;
					MaxTime = 2500;
					MinTime = 500;
					Value_Parking = 0;
					UsbBytesCount = 2;
					ComBytesCount = 2;
					break;

				// ------------------------------------------------- inputs
				case PinTypes.DIG_IN:
				case PinTypes.DIG_IN_PU:
					Value_Max = 1000;
					Value_Min = 0;
					Value_Parking = 0;
					UsbBytesCount = 1;
					ComBytesCount = 1;
					break;
				case PinTypes.ADC_8:
					Value_Max = 1000;
					Value_Min = 0;
					ResponseSpeed = 30;
					UsbBytesCount = 1;
					ComBytesCount = 1;
					break;
				case PinTypes.ADC_16:
					Value_Max = 1000;
					Value_Min = 0;
					ResponseSpeed = 30;
					UsbBytesCount = 2;
					ComBytesCount = 2;
					break;
				case PinTypes.CAP_8:
					Value_Max = 1000;
					Value_Min = 0;
					MinVariation = 20;
					ProportionalArea = 0;
					MeanValue = 0;
					ResponseSpeed = 30;
					UsbBytesCount = 1;
					ComBytesCount = 1;
					break;
				case PinTypes.CAP_16:
					Value_Max = 1000;
					Value_Min = 0;
					MinVariation = 20;
					ProportionalArea = 0;
					MeanValue = 0;
					ResponseSpeed = 30;
					UsbBytesCount = 2;
					ComBytesCount = 2;
					break;
				case PinTypes.RES_8:
					Value_Max = 1000;
					Value_Min = 0;
					ResponseSpeed = 30;
					UsbBytesCount = 1;
					ComBytesCount = 1;
					break;
				case PinTypes.RES_16:
					Value_Max = 1000;
					Value_Min = 0;
					ResponseSpeed = 30;
					UsbBytesCount = 2;
					ComBytesCount = 2;
					break;
				case PinTypes.COUNTER:
				case PinTypes.COUNTER_PU:
					Value_Max = 50000000;
					Value_Min = 0;
					MaxFreq = 50000000;
					MinFreq = 0;
					UsbBytesCount = 2;
					ComBytesCount = 2;
					break;
				case PinTypes.FAST_COUNTER:
				case PinTypes.FAST_COUNTER_PU:
					Value_Max = 50000000;
					Value_Min = 0;
					MaxFreq = 50000000;
					MinFreq = 0;
					UsbBytesCount = 2;
					ComBytesCount = 2;
					break;
				case PinTypes.PERIOD:
				case PinTypes.PERIOD_PU:
					Value_Max = 1000;
					Value_Min = 0;
					MaxFreq = 1000000;
					MinFreq = 0;
					ResponseSpeed = 30;
					UsbBytesCount = 4;
					ComBytesCount = 4;
					break;
				case PinTypes.USOUND_SENSOR:
					Value_Max = 1000;
					Value_Min = 0;
					MaxDist_mm = 1000;
					MinDist_mm = 0;
					ResponseSpeed = 30;
                    RemoveErrors = true;
					UsbBytesCount = 2;
					ComBytesCount = 2;
					break;
				case PinTypes.CAP_SENSOR:
					TimerDivision = 65536;
					TimerFrequencyKhz = 16000;
					Inductor_uh = 330;
					Cap_serial = 16;   //11.5   0 = infinite  ( normally 16 pF )
					Value_Max = 1000;
					Value_Min = 0;
					MaxDist_mm = 500;
					MinDist_mm = 50;
					ResponseSpeed = 30;
					Area_cmq = 50;
					UsbBytesCount = 3;
					ComBytesCount = 3;
					break;
				case PinTypes.I2C_SDA:
					UsbBytesCount = 1;
					ComBytesCount = 1;
					break;
				case PinTypes.I2C_SCL:
					UsbBytesCount = 1;
					ComBytesCount = 1;
					break;
				case PinTypes.MCA_8_BYTES:
					Value_Max = 65535;
					Value_Min = 0;
					UsbBytesCount = 8;
					ComBytesCount = 8;
					break;
				case PinTypes.MCA_16_BYTES:
					Value_Max = 65535;
					Value_Min = 0;
					UsbBytesCount = 16;
					ComBytesCount = 16;
					break;
				case PinTypes.MCA_32_BYTES:
					Value_Max = 65535;
					Value_Min = 0;
					UsbBytesCount = 32;
					ComBytesCount = 32;
					break;

				case PinTypes.SNIFFER:
					Value_Max = 0;
					Value_Min = 0;
					UsbBytesCount = 50;
					ComBytesCount = 0;
					break;

				case PinTypes.UNUSED:
					Value_Max = 1;
					Value_Min = 0;
					MaxTime = 1;
					MinTime = 0;
					Value_Parking = 0;
					UsbBytesCount = 0;
					ComBytesCount = 0;
					break;
				default:
					PinType = PinTypes.UNUSED;
					Value_Max = 1;
					Value_Min = 0;
					MaxTime = 1;
					MinTime = 0;
					Value_Parking = 0;
					UsbBytesCount = 0;
					ComBytesCount = 0;
					break;
			}

			// --------------------------------------------------------- direction
			if (PinType == PinTypes.UNUSED) {
				Direction = Directions.Unused;
			}
			else if (PinType < (PinTypes)128) {
				Direction = Directions.HostToMaster;
			}
			else {
				Direction = Directions.MasterToHost;
			}

		}



		// ==================================================================================================
		//  OUTPUTS  ( form SLOT to HARDWARE )
		// ==================================================================================================

		internal void ReadValueFromMMF()
		{
            if (Module_SaveLoad.CanUseWindowsDlls())
            {
                Value = MemoryMappedFiles.ReadSlot(Slot);
			}
			else {
                Value = MemoryMappedFiles_Unix.ReadSlot_Unix(Slot);
			}
		}


		internal void ConvertValueToHardwareFormat()
		{
			// -------------------------------------------------------------- min and max
			if (Value_Max != Value_Min) {
				Value_Normalized_New = (Value - Value_Min) / (Value_Max - Value_Min);
			}
			else {
				Value_Normalized_New = Value;
			}

			// -------------------------------------------------------------- exponential passing by 0 and 1
			//                                                                a little less that the log base ( 2.7182 ) 
			if (LogResponse && (PinType == PinTypes.PWM_8 | PinType == PinTypes.PWM_16)) {
				Value_Normalized_New = (float)Math.Pow(Value_Normalized_New, 2);
			}

			// -------------------------------------------------------------- limit to 0..1
			if (Value_Normalized_New < 0) Value_Normalized_New = 0; 
			if (Value_Normalized_New > 1) Value_Normalized_New = 1; 

			// -------------------------------------------------------------- speed 
            ThereminoSystem.Masters[MasterId].SmoothValue(ref Value_Normalized, Value_Normalized_New, ResponseSpeed);

			switch (PinType) {
				case PinTypes.DIG_OUT:
					if (float.IsNaN(Value_Normalized)) {
						Value_Normalized = 0;
					}

					if (Value_Normalized > 0.5) {
						Value_RawInteger = 1;
					}
					else {
						Value_RawInteger = 0;
					}


					break;
				case PinTypes.PWM_8:
				case PinTypes.SERVO_8:
					if (float.IsNaN(Value_Normalized)) {
						Value_Normalized = Value_Max > Value_Min ? 0 : 1;
						Value_RawInteger = 0;
					}
					else {
						Value_RawInteger = (uint)(16f * (Value_Normalized * (MaxTime - MinTime) + MinTime));
					}

					if (Value_RawInteger < 0) Value_RawInteger = 0; 
					if (Value_RawInteger > 64000) Value_RawInteger = 64000; 

					break;
				case PinTypes.PWM_16:
				case PinTypes.SERVO_16:
					if (float.IsNaN(Value_Normalized)) {
						Value_Normalized = Value_Max > Value_Min ? 0 : 1;
						Value_RawInteger = 0;
					}
					else {
						Value_RawInteger = (uint)(16f * (Value_Normalized * (MaxTime - MinTime) + MinTime));
					}

					if (Value_RawInteger < 0) Value_RawInteger = 0; 
					if (Value_RawInteger > 64000) Value_RawInteger = 64000; 

					break;
			}

		}

		internal void WriteValueToUsbBuffer()
		{
			switch (PinType) {
				case PinTypes.DIG_OUT:
                    ThereminoSystem.Masters[MasterId].Hid.USB_TxData[UsbByteIndex] = (byte)Value_RawInteger;
					break;
				case PinTypes.PWM_8:
				case PinTypes.SERVO_8:
                    ThereminoSystem.Masters[MasterId].Hid.USB_TxData[UsbByteIndex] = (byte)(Value_RawInteger / 256);
					break;
				case PinTypes.PWM_16:
				case PinTypes.SERVO_16:
                    byte[] bytes = Module_Utils.ByteArrayFromUint16((ushort)Value_RawInteger);
                    ThereminoSystem.Masters[MasterId].Hid.USB_TxData[UsbByteIndex] = bytes[0];
                    ThereminoSystem.Masters[MasterId].Hid.USB_TxData[UsbByteIndex + 1] = bytes[1];
					break;
			}
		}






		// ==================================================================================================
		//  INPUTS  ( form HARDWARE to SLOT )
		// ==================================================================================================

		internal void ReadValueFromUsbBuffer()
		{
			{
				switch (UsbBytesCount) {
					case 1:
                        Value_RawInteger = ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 0];
						break;
					case 2:
                        Value_RawInteger = ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 0] * 256u + ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 1];
						break;
					case 3:
                        Value_RawInteger = ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 0] * 65536u + ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 1] * 256u + ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 2];
						break;
					case 4:
                        Value_RawInteger = ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 0] * 256u * 65536u + ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 1] * 65536u + ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 2] * 256u + ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 3];
						break;
				}
				switch (PinType) {
					case PinTypes.SNIFFER:
						lock (SnifferLogLock) {
							{
                                nNewSniffedBytes = ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 0];
                                SnifferStatus = ThereminoSystem.Masters[MasterId].Hid.USB_RxData[UsbByteIndex + 1];
								if (SnifferLogEnabled) {
									for (Int32 i = 0; i <= nNewSniffedBytes - 1; i++) {
										if (nSniffedBytes >= SniffedBytes.Length - 1) break; // TODO: might not be correct. Was : Exit For

                                        SniffedBytes[nSniffedBytes] = ThereminoSystem.Masters[MasterId].Hid.USB_RxData[i * 2 + 2];
                                        SniffedFlags[nSniffedBytes] = ThereminoSystem.Masters[MasterId].Hid.USB_RxData[i * 2 + 3];
										nSniffedBytes += 1;
									}
								}
                                Value_RawInteger = ThereminoSystem.Masters[MasterId].Hid.USB_RxData[2];
								Value_Normalized_New = Value_RawInteger / 255f;
							}
						}

						break;
					case PinTypes.MCA_8_BYTES:
					case PinTypes.MCA_16_BYTES:
					case PinTypes.MCA_32_BYTES:
						break;
					//TODO
				}
			}
		}

		internal void ConvertValueFromHardwareFormat()
		{
			switch (PinType) {

				case PinTypes.DIG_IN:
				case PinTypes.DIG_IN_PU:
					if (Value_RawInteger != 0) Value_RawInteger = 1; 
					Value_Normalized_New = Value_RawInteger;
					break;

				case PinTypes.ADC_8:
					Value_Normalized_New = Value_RawInteger / 255f;
					break;

				case PinTypes.ADC_16:
					Value_Normalized_New = Value_RawInteger / 65535f;
					break;

				case PinTypes.CAP_8:
                    Value_RawInteger *= 3; // correction for (PIC24)Master and Servo values from (0 to 60 instead of 0 to 255)
					break;

				case PinTypes.CAP_16:
                    Value_RawInteger *= 3; // correction for (PIC24)Master and Servo values from (0 to 16000 instead of 0 to 65535)
					break;

				case PinTypes.RES_8:
					Value_Normalized_New = Value_RawInteger / 255f;
					break;

				case PinTypes.RES_16:
					Value_Normalized_New = Value_RawInteger / 65535f;
					break;

				case PinTypes.COUNTER:
				case PinTypes.COUNTER_PU:
				case PinTypes.FAST_COUNTER:
				case PinTypes.FAST_COUNTER_PU:
					break;

				case PinTypes.PERIOD:
				case PinTypes.PERIOD_PU:
					break;

				case PinTypes.USOUND_SENSOR:
                    if (RemoveErrors) UsoundSensor_RemoveErrors();
					UsoundSensor_CalculatePosition();
					break;

				case PinTypes.CAP_SENSOR:
					CapSensor_CalculateAll();
					break;
			}



			switch (PinType) {

				case PinTypes.DIG_IN:
				case PinTypes.DIG_IN_PU:
				case PinTypes.ADC_8:
				case PinTypes.ADC_16:
				case PinTypes.RES_8:
				case PinTypes.RES_16:
				case PinTypes.USOUND_SENSOR:
				case PinTypes.CAP_SENSOR:

					// -------------------------------------------------------------- limit to 0..1
					if (Value_Normalized_New < 0) Value_Normalized_New = 0; 
					if (Value_Normalized_New > 1) Value_Normalized_New = 1; 
					// -------------------------------------------------------------- speed
                    ThereminoSystem.Masters[MasterId].SmoothValue(ref Value_Normalized, Value_Normalized_New, ResponseSpeed);
					// -------------------------------------------------------------- min and max
					Value = Value_Normalized * (Value_Max - Value_Min) + Value_Min;

					break;

                case PinTypes.CAP_8:
                case PinTypes.CAP_16:
                    // -------------------------------------------------------------- speed before trigger
                    if (PinType == PinTypes.CAP_8)
                    {
                        ThereminoSystem.Masters[MasterId].SmoothValue(ref Value_RawSmooted,
                                                                      Value_RawInteger * (1000.0F / 255.0F),
                                                                      ResponseSpeed);
                    }
                    else
                    {
                        ThereminoSystem.Masters[MasterId].SmoothValue(ref Value_RawSmooted,
                                                                      Value_RawInteger * (1000.0F / 65535.0F),
                                                                      ResponseSpeed);
                    }

                    // ------------------------------------------------------------------ calculate delta
                    float delta = MeanValue - Value_RawSmooted;

                    // ------------------------------------------------------------------ increase min value
                    if (delta < 0)
                    {
                        MeanValue += (Value_RawSmooted - MeanValue) * 0.01f;
                        delta = 0;
                    }

                    // ------------------------------------------------------------------ MinVariation reduced for sliders
                    if (ProportionalArea > 0)
                    {
                        delta -= MinVariation / 100;
                    }
                    else
                    {
                        delta -= MinVariation;
                    }


                    if (ProportionalArea > 0)
                    {
                        // -------------------------------------------------------------- proportional limited 0..1
                        Value_Normalized = delta / ProportionalArea;
                        if (Value_Normalized < 0) Value_Normalized = 0;
                        if (Value_Normalized > 1) Value_Normalized = 1;
                    }
                    else if (ProportionalArea == 0)
                    {
                        //--------------------------------------------------------------- on/off (0 or 1)
                        Value_Normalized = delta > 0 ? 1 : 0;
                    }
                    else
                    {
                        // -------------------------------------------------------------- with velocity
                        if (delta > 0)
                        {
                            if (Velocity == 0)
                            {
                                Velocity = (delta - oldDelta3) / -ProportionalArea;
                                if (Velocity > 1) Velocity = 1;
                                Velocity = Velocity * Velocity;
                            }
                        }
                        else
                        {
                            Velocity = 0;
                        }
                        oldDelta3 = oldDelta2;
                        oldDelta2 = oldDelta1;
                        oldDelta1 = delta;
                        Value_Normalized = Velocity;
                    }

                    // ------------------------------------------------------------------ min and max
                    Value = Value_Normalized * (Value_Max - Value_Min) + Value_Min;

                    break;

				case PinTypes.COUNTER:
				case PinTypes.COUNTER_PU:
				case PinTypes.FAST_COUNTER:
				case PinTypes.FAST_COUNTER_PU:
					if (ConvertToFreq) {
					}
					// -------------------------------------------------------------- range
					//If Value_RawInteger > 0 Then
					//    Freq = 2000000.0F / Value_RawInteger
					//Else
					//    Freq = 0
					//End If
					//Dim range As Double = MaxFreq - MinFreq
					//If range < 0.1 Then range = 0.1
					//Value_Normalized_New = CSng((Freq - MinFreq) / range)
					// -------------------------------------------------------------- speed
					//FilterValueNormalizedBySpeed()
					// -------------------------------------------------------------- min and max
					//Value = Value_Normalized * (Value_Max - Value_Min) + Value_Min
					else {
						Value_Normalized_New = Value_RawInteger / 65535f;
						Value_Normalized = Value_Normalized_New;
						Value = Value_RawInteger;
					}


					break;

				case PinTypes.PERIOD:
				case PinTypes.PERIOD_PU:
					// Value_RawInteger = 0.0625 uSec ( 16 MHz )
					if (ConvertToFreq) {
						// -------------------------------------------------------------- range
						if (Value_RawInteger > 0) {
							Freq = 1.6E+07f / Value_RawInteger;
						}
						else {
							Freq = 0;
						}
						double range = MaxFreq - MinFreq;
						if (range < 0.1) range = 0.1; 
						Value_Normalized_New = (float)((Freq - MinFreq) / range);
						// -------------------------------------------------------------- speed
						ThereminoSystem.Masters[MasterId].SmoothValue(ref Value_Normalized, Value_Normalized_New, ResponseSpeed);
						// -------------------------------------------------------------- min and max
						Value = Value_Normalized * (Value_Max - Value_Min) + Value_Min;
					}
					else {
						Value_Normalized_New = Value_RawInteger / 1.677722E+07f / 2f;
						Value_Normalized = Value_Normalized_New;
						Value = Value_RawInteger;
					}


					break;

				case PinTypes.MCA_8_BYTES:
				case PinTypes.MCA_16_BYTES:
				case PinTypes.MCA_32_BYTES:
					break;
				// TODO


				case PinTypes.SNIFFER:
					Value_Normalized = Value_Normalized_New;
					Value = Value_Normalized * (Value_Max - Value_Min) + Value_Min;
					break;
				// ValueNormalized ( barra ) must follow nSniffed from 0 to 24 (slowly ?)

			}

		}


		internal void WriteValueToMMF()
		{
            if (Module_SaveLoad.CanUseWindowsDlls())
            {
                MemoryMappedFiles.WriteSlot(Slot, (float)Value);
			}
			else {
                MemoryMappedFiles_Unix.WriteSlot_Unix(Slot, (float)Value);
			}
		}



		// ==================================================================================================
		//   HELPER FUNCTIONS
		// ==================================================================================================

		internal void ResetPosMinMax()
		{
			Value_RawInteger_Min = 99999999;
			Value_RawInteger_Max = 0;
		}

		internal void Calibrate()
		{
			switch (PinType) {
				case PinTypes.CAP_SENSOR:
					// ----------------------------------------------- calibrate cap input
					Cap_zero = Cap_total;
					// ----------------------------------------------- calculate immediately the new position
					CapSensor_CalculatePosition();
					break;
                //case PinTypes.CAP_8:
                //case PinTypes.CAP_16:
                //    // ----------------------------------------------- calibrate cap input
                //    MeanValue = Value_RawSmooted;
                //    break;
			}
		}

		internal void CalibrateRawZero()
		{
			Value_RawInteger_Zero = Value_RawInteger;
		}

		internal string GetValueString()
		{
			CultureInfo ci = new CultureInfo("en-GB");
			switch (PinType) {

				// ------------------------------------------------------------------------- OUTPUTS
				case PinTypes.DIG_OUT:
					return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            " Slot: " + Value.ToString("0.00", ci) + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            "  Out: " + Value_RawInteger.ToString("0");
				
                case PinTypes.SERVO_8:
				case PinTypes.SERVO_16:
					return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            " Slot: " + Value_RawInteger.ToString("0.00", ci) + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            " uSec: " + Value_RawInteger.ToString("00000");
	
                case PinTypes.PWM_8:
				case PinTypes.PWM_16:
					return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            " Slot: " + Value_RawInteger.ToString("0.00", ci) + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            " uSec: " + Value_RawInteger.ToString("0000");

				// --------------------------------------------------------------------- INPUTS 
				case PinTypes.DIG_IN:
				case PinTypes.DIG_IN_PU:
					return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            "  Raw: " + Value_RawInteger.ToString("0") + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            " Slot: " + Value.ToString("0.00", ci);
				
                case PinTypes.ADC_8:
					return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            "  Raw: " + Value_RawInteger.ToString("000") + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            " Slot: " + Value.ToString("0.00", ci);
				
                case PinTypes.ADC_16:
					return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            "  Raw: " + Value_RawInteger.ToString("00000") + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            " Slot: " + Value.ToString("0.00", ci);
				
                case PinTypes.CAP_8:
				case PinTypes.CAP_16:
					return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            "   Raw: " + Value_RawInteger.ToString("000") + Constants.vbCrLf +
                            " Smoot: " + Value_RawSmooted.ToString("0.00") + Constants.vbCrLf +
                            "  Mean: " + MeanValue.ToString("0.00") + Constants.vbCrLf +
                            "  Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            "  Slot: " + Value.ToString("0.00", ci);
				
                case PinTypes.RES_8:
					return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            "  Raw: " + Value_RawInteger.ToString("000") + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            " Slot: " + Value.ToString("0.00", ci);
				
                case PinTypes.RES_16:
					return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            "  Raw: " + Value_RawInteger.ToString("00000") + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            " Slot: " + Value.ToString("0.00", ci);
				
                case PinTypes.COUNTER:
				case PinTypes.COUNTER_PU:
				case PinTypes.FAST_COUNTER:
				case PinTypes.FAST_COUNTER_PU:
				case PinTypes.PERIOD:
				case PinTypes.PERIOD_PU:
					if (ConvertToFreq) {
						return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            "  Raw: " + Value_RawInteger.ToString("00000") + Constants.vbCrLf +
                            " Freq: " + Freq.ToString("00000") + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            " Slot: " + Value.ToString("0.00", ci);
					}
					else {
						return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            "  Raw: " + Value_RawInteger.ToString("00000") + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                                " Slot: " + Value.ToString("00000");
					}

				case PinTypes.USOUND_SENSOR:
                    return PinTypeToString(PinType) + Constants.vbCrLf +
                            "--------------" + Constants.vbCrLf +
                            "  Raw: " + Value_RawInteger.ToString("00000") + Constants.vbCrLf +
                            "   mm: " + Dist_mm.ToString("0000") + Constants.vbCrLf +
                            " Norm: " + Value_Normalized.ToString("0.00", ci) + Constants.vbCrLf +
                            " Slot: " + Value.ToString("0.00", ci);
				
                case PinTypes.CAP_SENSOR:
					if (Value_RawInteger < 999999) {
						//
						string f = (Freq / 1000000).ToString("0.00000", ci);
						if (f == "Infinity") f = "---"; 
						//
						return "  Raw: " + Value_RawInteger.ToString("00000") + Constants.vbCrLf + 
                               "   mS: " + Millisec.ToString("0.0000", ci) + Constants.vbCrLf + 
                               "  MHz: " + f + Constants.vbCrLf + 
                               "C_tot: " + Cap_total.ToString("00.000", ci) + Constants.vbCrLf + 
                               " C_in: " + Cap_input.ToString("00.000", ci) + Constants.vbCrLf + 
                               "   mm: " + Dist_mm.ToString("0000") + Constants.vbCrLf + 
                               " Norm: " + Value_Normalized.ToString("0.00", ci);
					}
					break;

				case PinTypes.SNIFFER:

					// --------------------------------------------------------------------- 
					string s = PinTypeToString(PinType) + Constants.vbCrLf + "--------------" + Constants.vbCrLf + "      N:" + nNewSniffedBytes.ToString() + Constants.vbCrLf + " Status:" + SnifferStatus.ToString() + Constants.vbCrLf;

					// --------------------------------------------------------------------- 
                    if (My.MyProject.Forms.Form2.btn_TextLog.Checked)
                    {
						if (SnifferLogEnabled) {
							lock (SnifferLogLock) {
								{
									//nSniffedBytes = 1
									for (Int32 i = 0; i <= nSniffedBytes - 1; i++) {
										My.MyProject.Forms.Form2.rtb_SnifferLog.SelectionStart = 2000000000;
										My.MyProject.Forms.Form2.rtb_SnifferLog.SelectedText = SnifferStatus.ToString("000") + DecodeSnifferStatus(SnifferStatus) + "   " + SniffedFlags[i].ToString("000") + DecodeSnifferFlags(SniffedFlags[i]) + "   " + SniffedBytes[i].ToString("000") + Constants.vbCrLf;
										//.SelectionStart = .Text.Length - 1
										//.ScrollToCaret()
									}
									nSniffedBytes = 0;
								}
							}
						}
					}
					return s;

				// --------------------------------------------------------------------- 
				default:
					return PinTypeToString(PinType);

			}
			return "";
		}

		private string DecodeSnifferStatus(Int32 status)
		{
			string s = "( ";
			if ((status & 64) != 0) s += "Full "; 			else s += "---- "; 
			if ((status & 128) != 0) s += "Over "; 			else s += "---- "; 
			s += " )   ";
			return s;
		}

		private string DecodeSnifferFlags(Int32 flags)
		{
			string s = "( ";
			if ((flags & 1) != 0) s += "P "; 			else s += "p "; 
			if ((flags & 2) != 0) s += "F "; 			else s += "f "; 
			if ((flags & 4) != 0) s += "O "; 			else s += "o "; 
			if ((flags & 8) != 0) s += "MtS "; 			else s += "StM "; 
			s += " )   ";
			return s;
		}


		// ==================================================================================================
		//   USOUND SENSORS SPECIFIC
		// ==================================================================================================
		private void UsoundSensor_RemoveErrors()
		{
			//
            UInt32 diff = Module_MathFunctions.AbsUint32Difference(Value_RawInteger, Value_RawInteger_Old);
			Int32 maxErrorCount = 2 * (1 + (int)(30 / RepTime));
			//
			if (diff > 1000 & ErrorCounter < maxErrorCount) {
				Value_RawInteger = Value_RawInteger_Old;
				ErrorCounter += 1;
			}
			else {
				// ---------------------------------------------------------- use the new value
				Value_RawInteger_Old = Value_RawInteger;
				ErrorCounter = 0;
			}
		}

		private void UsoundSensor_CalculatePosition()
		{
			// -------------------------------------------------------------- distance in mm 
			Dist_mm = (Value_RawInteger - 900f) * 0.173f;
			// -------------------------------------------------------------- distance limits
			if (Dist_mm < MinDist_mm) Dist_mm = MinDist_mm; 
			if (Dist_mm > MaxDist_mm) Dist_mm = MaxDist_mm; 
			// -------------------------------------------------------------- range
			double range = MaxDist_mm - MinDist_mm;
			if (range < 0.1) range = 0.1; 
			Value_Normalized_New = 1 - (float)((Dist_mm - MinDist_mm) / range);
		}



		// ==================================================================================================
		//   CAP SENSORS SPECIFIC
		// ==================================================================================================
		private void CapSensor_CalculateAll()
		{
            CapSensor_LatencyBitsExtractor();
			//CapSensor_RemoveErrors();
			CapSensor_UpdateMinMaxValues();
			CapSensor_CalculateTimeAndFreq();
			CapSensor_CalculateTotalCap();
			CapSensor_CalculatePosition();
		}

        Int32 LatencySelector = 0;
        private void CapSensor_LatencyBitsExtractor()
		{
            LatencySelector = (Int32)(Value_RawInteger >> 20);
            Value_RawInteger = Value_RawInteger & 0xFFFFF;
        }

        //private void CapSensor_RemoveErrors()
        //{
        //    //
        //    Int32 MinCount = 200000;
        //    Int32 MinDiff = 35000;
        //    Int32 MaxDiff = 95000;
        //    Int32 maxErrorCount = 5 * (1 + (int)(30 / RepTime));
        //    //
        //    UInt32 diff = Module_MathFunctions.AbsUint32Difference(Value_RawInteger, Value_RawInteger_Old);
        //    //
        //    if ((Value_RawInteger < MinCount || (diff > MinDiff & diff < MaxDiff)) & ErrorCounter < 5) {
        //        // ------------------------------------------------------ show the error
        //        //frmMain.txt_Reports.Text &= "Invalid sample  " & _
        //        //                            "  OLD=" & _slave.CountOld.ToString & _
        //        //                            "  NEW=" & _slave.CountNew.ToString & _
        //        //                            "  DIFF=" & diff.ToString & vbCrLf
        //        Value_RawInteger = Value_RawInteger_Old;
        //        ErrorCounter += 1;
        //    }
        //    else {
        //        // ------------------------------------------------------ use the new value
        //        Value_RawInteger_Old = Value_RawInteger;
        //        ErrorCounter = 0;
        //    }
        //}

		// ------------------------------------------------- RawInteger min and max for AutoCalibrate
		private void CapSensor_UpdateMinMaxValues()
		{
			if (Value_RawInteger > Value_RawInteger_Max) Value_RawInteger_Max = Value_RawInteger; 
			if (Value_RawInteger < Value_RawInteger_Min) Value_RawInteger_Min = Value_RawInteger; 
		}

		private void CapSensor_CalculateTimeAndFreq()
		{
			// ---------------------------------------------------------- time total
			float ms = (float)Value_RawInteger / TimerFrequencyKhz;
			// ---------------------------------------------------------- frequency
			Freq = TimerDivision * 1000 / ms;
            // ---------------------------------------------------------- millisec corrected by latencyselector
            Millisec = ms / (float)(Math.Pow(2, LatencySelector));
		}

		private void CapSensor_CalculateTotalCap()
		{
			// ----------------------------------------------------------- total capacitance ( in parallel to inductor )
			Cap_total = (float)(2.53302955E+16 / (Inductor_uh * Math.Pow(Freq, 2)));
		}

		//Private Sub CapSensor_CalculatePosition()
		//    ' ----------------------------------------------------------- input capacitance ( after serial capacitor )
		//    If Cap_serial > 0 Then
        //        Cap_input = CSng(Module_ElectronicFormula.ELEC_C2_FromSerial(Cap_total - Cap_zero, Cap_serial))
		//    Else
		//        Cap_input = Cap_total - Cap_zero
		//    End If
		//    If Cap_input < 0 Then Cap_input = 0
		//    If Cap_input > 999.999 Then Cap_input = 999.999
		//    ' ----------------------------------------------------------- K area 
		//    ' Teoric K_Area is: 88 * 100 * Area_cmq
		//    ' from: 0.885F(cap. to dist. coeff.) * 100(cmq to mmq) * Area_cmq
		//    ' ---------
		//    ' A High coefficient ( 80 .. 160 ) expands the "Near" zone
		//    ' A Low coefficient  ( 40 .. 80 ) expands the "Far" zone
		//    ' ---------
		//    ' The user can change this Near-Far linearity 
		//    ' increasing or decreasing the parameter "Area_cmq" 
		//    ' ---------
		//    Dim K_Area As Single = 88 * Area_cmq
		//    ' ----------------------------------------------------------- distance in mm 
		//    Dist_mm = K_Area * MaxDist_mm / _
		//              (K_Area + Cap_input * MaxDist_mm * MaxDist_mm)
		//    ' ----------------------------------------------------------- distance limits
		//    If Dist_mm < 0 Then Dist_mm = 0
		//    If Dist_mm > MaxDist_mm Then Dist_mm = MaxDist_mm
		//    ' ----------------------------------------------------------- range
		//    Dim range As Double = MaxDist_mm - MinDist_mm
		//    If range < 0.1 Then range = 0.1
		//    Value_Normalized_New = 1 - CSng((Dist_mm - MinDist_mm) / range)
		//End Sub


		private void CapSensor_CalculatePosition()
		{
			// ----------------------------------------------------------- input capacitance ( after serial capacitor )
			if (Cap_serial > 0) {
                Cap_input = (float)Module_ElectronicFormula.ELEC_C2_FromSerial(Cap_total - Cap_zero, Cap_serial);
			}
			else {
				Cap_input = Cap_total - Cap_zero;
			}
			if (Cap_input < 0) Cap_input = 0; 
			if (Cap_input > 999.999F) Cap_input = 999.999F; 
			// ----------------------------------------------------------- K area 
			// Teoric K_Area is: 88 * 100 * Area_cmq
			// from: 0.885F(cap. to dist. coeff.) * 100(cmq to mmq) * Area_cmq
			// ---------
			// A High coefficient ( 80 .. 160 ) expands the "Near" zone
			// A Low coefficient  ( 40 .. 80 ) expands the "Far" zone
			// ---------
			// The user can change this Near-Far linearity 
			// increasing or decreasing the parameter "Area_cmq" 
			// ---------
			float K_Area = 88 * Area_cmq;
			// ----------------------------------------------------------- MaxDist and MinDist correction for area
			float K2 = Area_cmq / 100f;
			float MinD = MinDist_mm * K2;
			float MaxD = MaxDist_mm * K2;
			// ----------------------------------------------------------- distance in mm 
			Dist_mm = K_Area * MaxD / (K_Area + Cap_input * MaxD * MaxD);
			// ----------------------------------------------------------- distance limits
			if (Dist_mm < 0) Dist_mm = 0; 
			if (Dist_mm > MaxD) Dist_mm = MaxD; 
			// ----------------------------------------------------------- range
			double range = MaxD - MinD;
			if (range < 0.1) range = 0.1; 
			Value_Normalized_New = 1 - (float)((Dist_mm - MinD) / range);
		}

	}
}


