﻿
using Microsoft.VisualBasic;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.Diagnostics;

namespace Theremino_HAL
{
    public partial class Form1 : Form
    {
        private object EventsLock = new object();

        //private bool ForceClosing = false;
        private void Form1_Load(object sender, System.EventArgs e)
        {
            Timer_10Hz.Tick += Timer_10Hz_Tick;
            MyListView1.MouseUp += MyListView1_MouseUp;
            MyListView1.Resize += MyListView1_Resize;
            MyListView1.MouseDown += MyListView1_MouseDown;
            MyListView1.MouseMove += MyListView1_MouseMove;
            MyListView1.MouseDoubleClick += MyListView1_MouseDoubleClick;
            btn_Calibrate.ClickButtonArea += btn_Calibrate_ClickButtonArea;
            txt_CommSpeed.TextChanged += CommSpeed_TextChanged;
            chk_FastDataExchange.CheckedChanged += chk_FastDataExchange_CheckedChanged;
            txt_Slot.TextChanged += PinProps_Changed;
            txt_MaxValue.TextChanged += PinProps_Changed;
            txt_MinValue.TextChanged += PinProps_Changed;
            txt_ResponseSpeed.TextChanged += PinProps_Changed;
            txt_ServoMaxTime.TextChanged += PinProps_Changed;
            txt_ServoMinTime.TextChanged += PinProps_Changed;
            chk_LogResponse.CheckedChanged += PinProps_Changed;
            chk_RemoveErrors.CheckedChanged += PinProps_Changed;
            txt_CapMaxDist.TextChanged += PinProps_Changed;
            txt_CapMinDist.TextChanged += PinProps_Changed;
            txt_CapArea.TextChanged += PinProps_Changed;
            txt_MaxFreq.TextChanged += PinProps_Changed;
            txt_MinFreq.TextChanged += PinProps_Changed;
            txt_MinVariation.TextChanged += PinProps_Changed;
            txt_ProportionalArea.TextChanged += PinProps_Changed;
            txt_Slot.LostFocus += MasterProps_LostFocus;
            txt_CommSpeed.LostFocus += Master_CommProps_LostFocus;
            txt_Slot.LostFocus += PinProps_LostFocus;
            txt_MaxValue.LostFocus += PinProps_LostFocus;
            txt_MinValue.LostFocus += PinProps_LostFocus;
            txt_ResponseSpeed.LostFocus += PinProps_LostFocus;
            txt_CapMaxDist.LostFocus += PinProps_LostFocus;
            txt_CapMinDist.LostFocus += PinProps_LostFocus;
            txt_CapArea.LostFocus += PinProps_LostFocus;
            txt_ServoMaxTime.LostFocus += PinProps_LostFocus;
            txt_ServoMinTime.LostFocus += PinProps_LostFocus;
            chk_LogResponse.LostFocus += PinProps_LostFocus;
            chk_RemoveErrors.LostFocus += PinProps_LostFocus;
            txt_MaxFreq.LostFocus += PinProps_LostFocus;
            txt_MinFreq.LostFocus += PinProps_LostFocus;
            txt_MinVariation.LostFocus += PinProps_LostFocus;
            txt_ProportionalArea.LostFocus += PinProps_LostFocus;
            txt_MinChange.LostFocus += txt_MinChange_LostFocus;
            chk_ConvertToFrequency.CheckedChanged += chk_ConvertToFrequency_CheckedChanged;
            cmb_PinType.DropDown += cmb_PinType_DropDown;
            cmb_PinType.SelectionChangeCommitted += cmb_PinType_SelectionChangeCommitted;
            MyListView1.SelectedIndexChanged += MyListView1_SelectedIndexChanged;
            txt_CommSpeed.MouseEnter += txt_Min_MouseEnter;
            txt_MinChange.MouseEnter += txt_Min_MouseEnter;
            txt_CapArea.MouseEnter += txt_Min_MouseEnter;
            //
            // ++++++++++++++++++++++++++++++++ limit speed - TODO (correct and remove)
            txt_CommSpeed.MinValue = 1;
            txt_CommSpeed.MaxValue = 12;
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            //
            if (Module_SaveLoad.CanUseWindowsDlls())
            {
                MemoryMappedFiles.MemoryMappedFile_Init();
                MemoryMappedFiles.MemoryMappedFile_FillWithNanSleep();
            }
            else
            {
                MemoryMappedFiles_Unix.MemoryMappedFile_Init_Unix();
                MemoryMappedFiles_Unix.MemoryMappedFile_FillWithNanSleep_Unix();
            }
            //
            ToolTips_Init();
            VBMath.Randomize();
            Module_SaveLoad.Load_INI();
            Module_SaveLoad.Load_ConfigDatabase();
            Utils_LocaleNames.SetLocales();
                    // ---------------------------------------------------------------- REAL-TIME
            System.Threading.Thread.CurrentThread.Priority = System.Threading.ThreadPriority.Normal;
            System.Diagnostics.Process.GetCurrentProcess().PriorityClass = ProcessPriorityClass.RealTime;
            // ---------------------------------------------------------------- USB - MASTERS - SLAVES
            ThereminoSystem.TheSystem_InitMasters();
            ThereminoSystem.TheSystem_RecognizeSlaves();
            ThereminoSystem.TheSystem_StartTimers();
            // ---------------------------------------------------------------- Timer1 = 100mS = 10Hz 
            Timer_10Hz.Interval = 100;
            Timer_10Hz.Start();
            // ---------------------------------------------------------------- Timer_1Hz = 1000mS = 1Hz
            Timer_1Hz.Interval = 1000;
            Timer_1Hz.Start();
            // ---------------------------------------------------------------- WINDOW

            if (!Module_SaveLoad.CanUseWindowsDlls())
            {
                this.MinimumSize = new Size(650, 500);
            }
            if (!ThereminoSystem.ConfigurationIsValid)
            {
                WindowState = FormWindowState.Normal;
            }
            if (Module_SaveLoad.Form2_VisibleAtStart)
            {
                My.MyProject.Forms.Form2.Show();
            }
            else
            {
                My.MyProject.Forms.Form2.Visible = false;
            }
            Text = Module_SaveLoad.AppTitleAndVersion("Theremino HAL - C#");
            // ----------------------------------------------------------------
            Module_SaveLoad.EventsAreEnabled = true;
            // ----------------------------------------------------------------
            Module_Utils.ListView_SelectLine(MyListView1, 0);
            ShowProps();
            //
            MyListView1.Focus();
        }


        private void Form1_FormClosing(object sender, System.Windows.Forms.FormClosingEventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;

            ThereminoSystem.TheSystem_StopTimers();
            ThereminoSystem.TheSystem_SetParkingPositions();
            ThereminoSystem.TheSystem_UpdateAndSaveConfigDatabase();
            Module_SaveLoad.Save_INI();
        }

        private void Form1_LocationChanged(object sender, System.EventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;

            Module_SaveLoad.LimitFormPosition(this);
        }

        private void CloseAllAndExit()
        {
            ThereminoSystem.TheSystem_StopTimers();
            ThereminoSystem.TheSystem_SetParkingPositions();
            ThereminoSystem.TheSystem_UpdateAndSaveConfigDatabase();
            Module_SaveLoad.Save_INI();
        }



        //  =======================================================================================
        //    MENU FILE
        //  =======================================================================================
        private void Menu_File_EditConfigurations_Click(object sender, System.EventArgs e)
        {
            Process.Start((Application.StartupPath + "\\Theremino_HAL_ConfigDatabase.txt"));
        }

        private void Menu_File_OpenProgramFolder_Click(object sender, System.EventArgs e)
        {
            Process.Start(Application.StartupPath);
        }

        private void Menu_File_Recognize_Click(object sender, System.EventArgs e)
        {
            Cmd_Recognize();
        }

        private void Menu_File_Validate_Click(object sender, System.EventArgs e)
        {
            Cmd_Validate();
        }

        private void Menu_File_Exit_Click(object sender, System.EventArgs e)
        {
            CloseAllAndExit();
            this.Close();
        }


        //  =======================================================================================
        //    MENU LANGUAGE
        //  =======================================================================================
        private void Menu_Language_DropDownOpening(object sender, System.EventArgs e)
        {
            foreach (ToolStripMenuItem item in Menu_Language.DropDownItems)
            {
                if (item.Name.EndsWith(Utils_LocaleNames.Language, StringComparison.InvariantCultureIgnoreCase))
                {
                    item.Select();
                }
            }
        }

        private void Menu_Language_Deutsch_Click(object sender, System.EventArgs e)
        {
            Utils_LocaleNames.Language = "Deutsch";
            Utils_LocaleNames.SetLocales();
            Module_SaveLoad.Save_INI();
        }

        private void Menu_Language_English_Click(object sender, System.EventArgs e)
        {
            Utils_LocaleNames.Language = "English";
            Utils_LocaleNames.SetLocales();
            Module_SaveLoad.Save_INI();
        }

        private void Menu_Language_Espanol_Click(object sender, System.EventArgs e)
        {
            Utils_LocaleNames.Language = "Espanol";
            Utils_LocaleNames.SetLocales();
            Module_SaveLoad.Save_INI();
        }

        private void Menu_Language_Francais_Click(object sender, System.EventArgs e)
        {
            Utils_LocaleNames.Language = "Francais";
            Utils_LocaleNames.SetLocales();
            Module_SaveLoad.Save_INI();
        }

        private void Menu_Language_Italian_Click(object sender, System.EventArgs e)
        {
            Utils_LocaleNames.Language = "Italian";
            Utils_LocaleNames.SetLocales();
            Module_SaveLoad.Save_INI();
        }

        private void Menu_Language_Japanese_Click(object sender, System.EventArgs e)
        {
            Utils_LocaleNames.Language = "Japanese";
            Utils_LocaleNames.SetLocales();
            Module_SaveLoad.Save_INI();
        }

        
        //  =======================================================================================
        //    MENU HELP
        //  =======================================================================================
        private void Menu_Help_ProgramHelp_Click(object sender, System.EventArgs e)
        {
            OpenLocalizedHelp("ThereminoHAL_Help", ".pdf");
        }

        private void ToDoListToolStripMenuItem_Click(object sender, System.EventArgs e)
        {
            OpenLocalizedHelp("ToDo", ".txt");
        }

        private void OpenLocalizedHelp(string name, string ext)
        {
            if (ext == "") ext = ".rtf";

            string fname = Module_SaveLoad.PlatformAdjustedFileName((Application.StartupPath + ("\\Docs\\"
                            + (name + ("_"
                            + Utils_LocaleNames.Language + ext)))), "");
    
            if (Module_SaveLoad.FileExists(fname))
            {
                Process.Start(fname);
            }
            else
            {
                fname = Module_SaveLoad.PlatformAdjustedFileName((Application.StartupPath + ("\\Docs\\"
                                + (name + ("_ENG" + ext)))), "");
                if (Module_SaveLoad.FileExists(fname))
                {
                    Process.Start(fname);
                }
                else
                {
                    fname = Module_SaveLoad.PlatformAdjustedFileName((Application.StartupPath + ("\\Docs\\"
                                    + (name + ("_ITA" + ext)))), "");
                    if (Module_SaveLoad.FileExists(fname))
                    {
                        Process.Start(fname);
                    }
                    else
                    {
                        fname = Module_SaveLoad.PlatformAdjustedFileName((Application.StartupPath + ("\\Docs\\"
                                        + (name + ext))), "");
                        if (Module_SaveLoad.FileExists(fname))
                        {
                            Process.Start(fname);
                        }
                    }
                }
            }
        }
        
        //  =======================================================================================
        //    MENU ABOUT
        //  =======================================================================================
        private void Menu_About_Click(object sender, System.EventArgs e)
        {
            My.MyProject.Forms.Form_About.ShowDialog();
        }
        
        //  =======================================================================================
        //    TOOLBAR
        //  =======================================================================================
        private void ToolStripButton_EditConfigurations_Click(object sender, System.EventArgs e)
        {
            Process.Start((Application.StartupPath + "\\Theremino_HAL_ConfigDatabase.txt"));
        }

        private void ToolStripButton_Recognize_Click(object sender, System.EventArgs e)
        {
            Cmd_Recognize();
        }

        private void ToolStripButton_Validate_Click(object sender, System.EventArgs e)
        {
            Cmd_Validate();
        }

        private void ToolStrip1_MouseEnter(object sender, System.EventArgs e)
        {
            this.Focus();
            //  with this the toolstrip responds always to the first click
        }
        


        // ===========================================================================================================
        //   Commands execution
        // ===========================================================================================================

        private void Cmd_Recognize()
        {
            Module_SaveLoad.EventsAreEnabled = false;
            Int32 OldSelectedLine = SelectedLine;
            Module_SaveLoad.Load_ConfigDatabase();
            Timer_10Hz.Stop();
            ThereminoSystem.TheSystem_StopTimers();
            ThereminoSystem.TheSystem_InitMasters();
            ThereminoSystem.TheSystem_RecognizeSlaves();
            ShowProps();
            ThereminoSystem.TheSystem_StartTimers();
            Timer_10Hz.Start();
            Module_SaveLoad.EventsAreEnabled = true;
            if (OldSelectedLine < 0) OldSelectedLine = 0;
            Module_Utils.ListView_SelectLine(MyListView1, OldSelectedLine);
            My.MyProject.Forms.Form2.DeselectAllPins();
        }

        private void Cmd_Validate()
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;
            Module_SaveLoad.EventsAreEnabled = false;
            Int32 OldSelectedLine = SelectedLine;
            ThereminoSystem.TheSystem_ValidateConfiguration();
            ThereminoSystem.TheSystem_UpdateAndSaveConfigDatabase();
            ThereminoSystem.TheSystem_StartTimers();
            Module_SaveLoad.EventsAreEnabled = true;
            Module_Utils.ListView_SelectLine(MyListView1, OldSelectedLine);
        }

        private void btn_Calibrate_ClickButtonArea(object Sender, System.EventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled)
            {
                return;
            }
            Module_SaveLoad.EventsAreEnabled = false;
            DoCalibrationAndResetTime();
            CalibrationTime = 0.8;
            btn_Calibrate.Refresh();
            Module_SaveLoad.EventsAreEnabled = true;
        }




        // ===========================================================================================================
        //   UPDATES
        // ===========================================================================================================

        private void Timer_10Hz_Tick(System.Object sender, System.EventArgs e)
        {
            lock (EventsLock)
            {
                //
                if (WindowState != FormWindowState.Minimized)
                {
                    // ---------------------------------------------------------- UpdateListedValues
                    ThereminoSystem.TheSystem_UpdateListedValues();
                    // ---------------------------------------------------------- update RepeatFrequency
                    Master m = ThereminoSystem.GetMasterByListLine(SelectedLine, LineType(SelectedLine));
                    if (m != null)
                    {
                        lbl_RepeatFrequency.Text = m.CommFps.ToString("0");
                        if (m.CommFps < 50)
                        {
                            lbl_RepeatFrequency.BackColor = Color.LightSalmon;
                        }
                        else
                        {
                            lbl_RepeatFrequency.BackColor = Color.Transparent;
                        }
                        lbl_ErrorRate.Text = m.ErrorRate.ToString("0.00", System.Globalization.CultureInfo.InvariantCulture);
                        if (m.ErrorRate >= 0.1)
                        {
                            lbl_ErrorRate.BackColor = Color.LightSalmon;
                            m.SetSpeed();
                        }
                        else
                        {
                            lbl_ErrorRate.BackColor = Color.Transparent;
                        }
                        if (m.ErrorRate >= 0.01)
                        {
                            if (ToolStripButton_BeepOnErrors.Checked) Interaction.Beep();
                        }
                    }
                }
                //
                if (EditValue_MouseEditFlag)
                {
                    // ---------------------------------------------------------- edit
                    if (Module_Utils.LeftMousePressed())
                    {
                        EditValue_MouseMove();
                    }
                    else
                    {
                        ShowCursor();
                        EditValue_MouseEditFlag = false;
                    }
                }
                //
            }
        }

        private void MyListView1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            My.MyProject.Forms.Form2.SetPinDetails();
        }

        private void MyListView1_Resize(object sender, System.EventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;

            ThereminoSystem.TheSystem_ListViewResize();
        }



        // ===========================================================================================================
        //   EDIT VALUES
        // ===========================================================================================================

        private bool EditValue_MouseEditFlag = false;
        private Int32 EditValue_Slot;
        private Int32 EditValue_Multiplier;
        private Point EditValue_StartCursorPos;
        private float EditValue_MaxValue;

        private float EditValue_MinValue;
        private void MyListView1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            StartMouseEdit();
        }

        private void StartMouseEdit()
        {
            if (EditValue_MouseEditFlag) return;
            Int32 column = Module_Utils.ListView_GetColumnIndex(MyListView1);
            Int32 line = Module_Utils.ListView_GetLineIndex(MyListView1);
            if (column == 5 & line >= 0)
            {
                string slotString = MyListView1.Items[line].SubItems[4].Text;
                if (!string.IsNullOrEmpty(slotString))
                {
                    Pin p = ThereminoSystem.FindPinByListLine(line);
                    if (p != null && p.GetPinType() != Pin.PinTypes.UNUSED)
                    {
                        HideCursor();
                        EditValue_MouseEditFlag = true;
                        EditValue_StartCursorPos = Cursor.Position;
                        // ----------------------------------------------------------------------
                        EditValue_Slot = p.Slot;
                        EditValue_MaxValue = (float)Math.Max(p.Value_Max, p.Value_Min);
                        EditValue_MinValue = (float)Math.Min(p.Value_Max, p.Value_Min);
                        EditValue_Multiplier = 1;
                        Int32 range = (int)Math.Abs(p.Value_Max - p.Value_Min);
                        if (range > 500) EditValue_Multiplier = 2;
                        if (range > 1000) EditValue_Multiplier = 5;
                        if (range > 2000) EditValue_Multiplier = 10;
                        if (range > 5000) EditValue_Multiplier = 20;
                        if (range > 10000) EditValue_Multiplier = 50;
                    }
                }
            }
        }

        private void MyListView1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;

            if (EditValue_MouseEditFlag)
            {
                EditValue_MouseMove();
            }
        }

        private void EditValue_MouseMove()
        {
            Int32 delta = EditValue_StartCursorPos.Y - Cursor.Position.Y;
            Cursor.Position = EditValue_StartCursorPos;
            ChangeValueByDelta(delta);
        }

        private void ChangeValueByDelta(float delta)
        {
            //Form2.StopTimer()
            Module_SaveLoad.EventsAreEnabled = false;

            float v = 0;
            if (Module_SaveLoad.CanUseWindowsDlls())
            {
                v = MemoryMappedFiles.ReadSlot(EditValue_Slot);
            }
            else
            {
                v = MemoryMappedFiles_Unix.ReadSlot_Unix(EditValue_Slot);
            }

            if (float.IsNaN(v))
            {
                v = EditValue_MinValue - 9;
            }
            //
            v += delta * EditValue_Multiplier;
            v = Math.Min(v, EditValue_MaxValue);
            //v = Math.Max(v, EditValue_MinValue)
            //
            if (v < EditValue_MinValue)
            {
                if (v < -8)
                {
                    v = MemoryMappedFiles.NAN_Sleep;
                }
                else
                {
                    v = EditValue_MinValue;
                }
            }
            //
            if (Module_SaveLoad.CanUseWindowsDlls())
            {
                MemoryMappedFiles.WriteSlot(EditValue_Slot, v);
            }
            else
            {
                MemoryMappedFiles_Unix.WriteSlot_Unix(EditValue_Slot, v);
            }
            //
            Application.DoEvents();

            Module_SaveLoad.EventsAreEnabled = true;
            //Form2.StartTimer()
        }

        private void MyListView1_MouseDoubleClick(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            My.MyProject.Forms.Form2.Show();
        }


        // ---------------------------------------------------------------------------------------------------
        //  MyListView1.Activation = ItemActivation.Standard   <<<< USE THIS OR THE CURSOR CAN NOT BE CHANGED
        // ---------------------------------------------------------------------------------------------------
        //private Cursor BlankCursor = new Cursor(new System.IO.MemoryStream(My.Resources.Resources.Blank));
        private void HideCursor()
        {
            Cursor.Hide();
            //MyListView1.Cursor = BlankCursor;
        }
        private void ShowCursor()
        {
            Cursor.Show();
            MyListView1.Cursor = Cursors.Hand;
        }



        // ===========================================================================================================
        //   SET MASTER AND PIN PROPERTIES
        // ===========================================================================================================

        private void btn_MasterName_ClickButtonArea(object Sender, EventArgs e)
        {
            string newName;
            newName = Microsoft.VisualBasic.Interaction.InputBox("New name for the selected master",
                                                                 "Edit Master name",
                                                                 cmb_MasterNames.Text,
                                                                 this.Right - 370,
                                                                 this.Top + 125);
            if (newName != "") Change_SelectedMaster_Name(newName);
        }

        private void Change_SelectedMaster_Name(string newName)
        {
            this.Cursor = Cursors.AppStarting;
            // --------------------------------------------------------------------- init master
            Master m;
            m = ThereminoSystem.GetMasterByListLine(SelectedLine, LineType(SelectedLine));
            if (m == null) return;
            string oldName = m.GetName();
            // --------------------------------------------------------------------- try to change the hardware name
            if (newName != oldName)
            {
                for (Int32 i = 1; i <= 3; i++)
                {
                    m.SetName(newName);
                    m.WriteNameToHardware();
                    m.ReadNameFromHardware();
                    if (m.GetName() == newName)
                    {
                        Cmd_Recognize();
                        Module_Utils.Combo_Init(cmb_MasterNames, newName);
                        ThereminoSystem.TheSystem_UpdateListedSubtypes();
                        ThereminoSystem.TheSystem_UpdateConfigDatabase();
                        ThereminoSystem.TheSystem_SaveConfigDatabase();
                        break;
                    }
                }
            }
            this.Cursor = Cursors.Default;
        }


        //private const bool CommitOnlyWithEnterKey = false;

        //private void txt_Name_TextChanged(System.Object sender, System.EventArgs e)
        //{
        //    if (SelectedLine < 0) return;

        //    if (!Module_SaveLoad.EventsAreEnabled) return;

        //    Module_SaveLoad.EventsAreEnabled = false;

        //    // ------------------------------------------------------ commit only with ENTER key
        //    //if (CommitOnlyWithEnterKey)
        //    //{
        //    //    if (!txt_Name.Text.Contains(Constants.vbCrLf))
        //    //    {
        //    //        Module_SaveLoad.EventsAreEnabled = true;
        //    //        return;
        //    //    }
        //    //    Theremino_HAL.My.MyProject.Computer.Audio.PlaySystemSound(System.Media.SystemSounds.Exclamation);
        //    //}

        //    // ------------------------------------------------------ remove CrLf and initial annd final spaces
        //    Int32 oldCursorPos = txt_Name.SelectionStart;
        //    //
        //    txt_Name.Text = txt_Name.Text.Replace(Constants.vbCr, "");
        //    txt_Name.Text = txt_Name.Text.Replace(Constants.vbLf, "");
        //    txt_Name.Text = txt_Name.Text.Trim();
        //    //
        //    txt_Name.SelectionStart = oldCursorPos;

        //    // ------------------------------------------------------ init master
        //    Master m = null;
        //    m = ThereminoSystem.GetMasterByListLine(SelectedLine, LineType(SelectedLine));
        //    if (m == null)
        //    {
        //        Module_SaveLoad.EventsAreEnabled = true;
        //        return;
        //    }

        //    string oldName = m.GetName();
        //    string newName = txt_Name.Text;

        //    // ------------------------------------------------------ test the HID
        //    if (!m.Hid.MyDeviceDetected)
        //    {
        //        txt_Name.Text = oldName;
        //        txt_Name.SelectionStart = oldCursorPos;
        //        Module_SaveLoad.EventsAreEnabled = true;
        //        return;
        //    }

        //    // ------------------------------------------------------ detect if the NewName already exists in the database
        //    //Int32 ExistingConfigId = default(Int32);
        //    //ExistingConfigId = ThereminoSystem.FindConfigByName(newName);
        //    //if (ExistingConfigId >= 0 & ExistingConfigId != m.ConfigId)
        //    //{
        //    //    Interaction.MsgBox("The configuration: \"" + newName + "\" already exists." + Constants.vbCr + Constants.vbCr + "Please use another name.", MsgBoxStyle.OkOnly, "");
        //    //    txt_Name.Text = oldName;
        //    //    txt_Name.SelectionStart = oldCursorPos;
        //    //    Module_SaveLoad.EventsAreEnabled = true;
        //    //    return;
        //    //}

        //    //If newName = "NoName" Then
        //    //    MsgBox("The name: ""NoName"" is not allowed." & vbCr & vbCr & _
        //    //           "Please use another name.", MsgBoxStyle.OkOnly)
        //    //    txt_Name.Text = oldName
        //    //    txt_Name.SelectionStart = oldCursorPos
        //    //    Module_SaveLoad.EventsAreEnabled = True
        //    //    Return
        //    //End If

        //    //if (string.IsNullOrEmpty(newName))
        //    //{
        //    //    Interaction.MsgBox("Empty names are not allowed." + Constants.vbCr + Constants.vbCr + "Please use another name.", MsgBoxStyle.OkOnly, "");
        //    //    txt_Name.Text = oldName;
        //    //    txt_Name.SelectionStart = oldCursorPos;
        //    //    Module_SaveLoad.EventsAreEnabled = true;
        //    //    return;
        //    //}

        //    // -------------------------------------------------------- try to change the hardware name
        //    if (newName != oldName)
        //    {
        //        //
        //        for (Int32 i = 1; i <= 3; i++)
        //        {
        //            m.SetName(newName);
        //            m.WriteNameToHardware();
        //            m.ReadNameFromHardware();
        //            if (m.GetName() == newName) break; // TODO: might not be correct. Was : Exit For

        //        }
        //        //
        //        ThereminoSystem.TheSystem_UpdateListedSubtypes();
        //        ThereminoSystem.TheSystem_UpdateConfigDatabase();
        //    }

        //    Module_SaveLoad.EventsAreEnabled = true;
        //}

        private void CommSpeed_TextChanged(System.Object sender, System.EventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;

            if (SelectedLine < 0) return;

            Timer_10Hz.Stop();
            Master m = ThereminoSystem.GetMasterByListLine(SelectedLine, LineType(SelectedLine));
            if (m != null)
            {
                m.SetSpeed(txt_CommSpeed.NumericValueInteger);
                txt_CommSpeed.Refresh();
                // -------------------------------------------------- save changes to database immediately
                ThereminoSystem.TheSystem_UpdateConfigDatabase();
            }
            Timer_10Hz.Start();
        }

        private void chk_FastDataExchange_CheckedChanged(System.Object sender, System.EventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;

            if (SelectedLine < 0) return;

            Master m = ThereminoSystem.GetMasterByListLine(SelectedLine, LineType(SelectedLine));
            if (m != null)
            {
                m.FastComm = chk_FastDataExchange.Checked;
                // -------------------------------------------------- save changes to database immediately
                ThereminoSystem.TheSystem_UpdateConfigDatabase();
            }
        }



        private void PinProps_Changed(System.Object sender, System.EventArgs e)
        {

            if (!Module_SaveLoad.EventsAreEnabled) return;

            if (SelectedLine < 0) return;

            SetPinProps();
        }


        private void SetPinProps()
        {
            switch (LineType(SelectedLine))
            {
                case "Pin":
                    Pin p = ThereminoSystem.FindPinByListLine(SelectedLine);
                    Int32 n = txt_Slot.NumericValueInteger;
                    if (n != p.Slot)
                    {
                        p.Slot = n;
                        string Str = p.Slot.ToString();
                        {
                            if (Str != MyListView1.Items[SelectedLine].SubItems[4].Text) MyListView1.Items[SelectedLine].SubItems[4].Text = Str;
                        }
                    }

                    //
                    p.Value_Max = (float)txt_MaxValue.NumericValue;
                    p.Value_Min = (float)txt_MinValue.NumericValue;
                    p.ResponseSpeed = txt_ResponseSpeed.NumericValueInteger;
                    //
                    switch (p.GetPinType())
                    {
                        case Pin.PinTypes.SERVO_8:
                        case Pin.PinTypes.SERVO_16:
                            p.MaxTime = (float)txt_ServoMaxTime.NumericValue;
                            p.MinTime = (float)txt_ServoMinTime.NumericValue;
                            break;
                        case Pin.PinTypes.PWM_8:
                        case Pin.PinTypes.PWM_16:
                            p.MaxTime = (float)txt_ServoMaxTime.NumericValue;
                            p.MinTime = (float)txt_ServoMinTime.NumericValue;
                            p.LogResponse = chk_LogResponse.Checked;
                            break;
                        case Pin.PinTypes.CAP_8:
                        case Pin.PinTypes.CAP_16:
                            p.MinVariation = (float)txt_MinVariation.NumericValue;
                            p.ProportionalArea = (float)txt_ProportionalArea.NumericValue;
                            break;
                        case Pin.PinTypes.USOUND_SENSOR:
                            p.MaxDist_mm = (float)txt_CapMaxDist.NumericValue;
                            p.MinDist_mm = (float)txt_CapMinDist.NumericValue;
                            p.RemoveErrors = chk_RemoveErrors.Checked;
                            break;
                        case Pin.PinTypes.CAP_SENSOR:
                            p.MaxDist_mm = (float)txt_CapMaxDist.NumericValue;
                            p.MinDist_mm = (float)txt_CapMinDist.NumericValue;
                            p.Area_cmq = (float)txt_CapArea.NumericValue;
                            break;
                        case Pin.PinTypes.COUNTER:
                        case Pin.PinTypes.COUNTER_PU:
                        case Pin.PinTypes.FAST_COUNTER:
                        case Pin.PinTypes.FAST_COUNTER_PU:
                        case Pin.PinTypes.PERIOD:
                        case Pin.PinTypes.PERIOD_PU:
                            p.MaxFreq = (float)txt_MaxFreq.NumericValue;
                            p.MinFreq = (float)txt_MinFreq.NumericValue;
                            p.ConvertToFreq = chk_ConvertToFrequency.Checked;
                            break;
                    }
                    //
                    ThereminoSystem.TheSystem_UpdateConfigDatabase();
                    break;
            }
        }





        // ====================================================================================================
        //   PARAMS LOST FOCUS - SaveConfigDatabase 
        // ====================================================================================================


        private void MasterProps_LostFocus(System.Object sender, System.EventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;
            ThereminoSystem.TheSystem_SaveConfigDatabase();
        }


        private void Master_CommProps_LostFocus(System.Object sender, System.EventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;
            ThereminoSystem.TheSystem_SaveConfigDatabase();
        }


        private void PinProps_LostFocus(System.Object sender, System.EventArgs e)
        {

            ThereminoSystem.TheSystem_SaveConfigDatabase();
        }


        private void txt_MinChange_LostFocus(object sender, System.EventArgs e)
        {

        }


        private void chk_ConvertToFrequency_CheckedChanged(object Sender, System.EventArgs e)
        {
            SetPinProps();
            ThereminoSystem.TheSystem_SaveConfigDatabase();
            ShowProps();
        }


        // ====================================================================================================
        //   COMBO MASTER NAMES
        // ====================================================================================================
        private void cmb_MasterNames_DropDown(object sender, EventArgs e)
        {
            string oldname = cmb_MasterNames.Items[0].ToString();
            cmb_MasterNames.ItemHeight = 16;
            cmb_MasterNames.Items.Clear();
            Module_SaveLoad.Load_ConfigDatabase();
            ThereminoSystem.FillConfigNamesCombo(cmb_MasterNames);
            Module_Utils.Combo_SetIndex_FromString(cmb_MasterNames, oldname);
        }
        private void cmb_MasterNames_DropDownClosed(object sender, EventArgs e)
        {
            cmb_MasterNames.ItemHeight = 12;
            Module_Utils.Combo_Init(cmb_MasterNames, cmb_MasterNames.Text);
        }
        private void cmb_MasterNames_SelectionChangeCommitted(object sender, EventArgs e)
        {
            Change_SelectedMaster_Name(cmb_MasterNames.Text);
        }

        // ====================================================================================================
        //   COMBO PIN TYPE
        // ====================================================================================================

        private void cmb_PinType_DropDown(object sender, System.EventArgs e)
        {
            cmb_PinType.ItemHeight = 16;
            Pin p = ThereminoSystem.FindPinByListLine(SelectedLine);
            ThereminoSystem.Masters[p.MasterId].Slaves[p.SlaveId].FillTypeCombo(cmb_PinType, ref p);
            Module_Utils.Combo_SetIndex_FromString(cmb_PinType, Pin.PinTypeToString(p.GetPinType()));
        }
        private void cmb_PinType_DropDownClosed(object sender, EventArgs e)
        {
            cmb_PinType.ItemHeight = 12;
        }
        private void cmb_PinType_SelectionChangeCommitted(object sender, System.EventArgs e)
        {
            Pin p = ThereminoSystem.FindPinByListLine(SelectedLine);

            // TODO -------------------------------------------------------------- This must be atomic
            p.SetPinType(Pin.StringToPinType(cmb_PinType.Items[cmb_PinType.SelectedIndex].ToString()));
            ThereminoSystem.Masters[p.MasterId].SetupSlavePins(p.SlaveId);
            // ----------------------------------------------------------------------------------------

            // -------------------------------------------------------------------------- 
            Module_Utils.Combo_Init(cmb_PinType, Pin.PinTypeToString(p.GetPinType()));
            // -------------------------------------------------------------------------- set PinType and Direction
            ThereminoSystem.TheSystem_UpdateListedSubtypes();
            {
                MyListView1.Items[SelectedLine].SubItems[2].Text = Pin.PinTypeToString(p.GetPinType());
                MyListView1.Items[SelectedLine].SubItems[3].Text = p.GetDirectionString();
                MyListView1.Items[SelectedLine].SubItems[4].Text = p.GetPinType() == Pin.PinTypes.UNUSED ? "" : p.Slot.ToString();
                MyListView1.Items[SelectedLine].SubItems[5].Text = "";
            }
            // -------------------------------------------------------------------------- set Color
            ListView_SetAllLineColors();
            // -------------------------------------------------------------------------- set pin props
            ShowProps();
            SetPinProps();
            // -------------------------------------------------------------------------- 
            ThereminoSystem.TheSystem_UpdateAndSaveConfigDatabase();
            // -------------------------------------------------------------------------- 
            btn_Calibrate.Enabled = ThereminoSystem.TheSystem_CalibrationNeeded();
            if (btn_Calibrate.Enabled)
            {
                //If p.GetPinType = Pin.PinTypes.CAP_16 Or _
                //  p.GetPinType = Pin.PinTypes.CAP_8 Or _
                //  p.GetPinType = Pin.PinTypes.CAP_SENSOR Then
                if (p.GetPinType() == Pin.PinTypes.CAP_SENSOR)
                {
                    DoCalibrationAndResetTime();
                }
            }
        }



        // ===========================================================================================================
        //   SHOW PROPS
        // ===========================================================================================================

        internal void ListView_SetAllLineColors()
        {
            // -------------------------------------------------------------------- select the listview "SelectedLine"
            if (SelectedLine >= 0 & SelectedLine < MyListView1.Items.Count)
            {
                MyListView1.Items[SelectedLine].Selected = true;
            }
            // -------------------------------------------------------------------- show listview colors
            for (Int32 i = 0; i <= MyListView1.Items.Count - 1; i++)
            {
                ListView_SetLineColors(MyListView1, i);
            }
        }


        private void ListView_SetLineColors(ListView lv, Int32 line)
        {
            if (line < 0 | line >= lv.Items.Count) return;
            //
            Color fc = default(Color);
            Color bc = default(Color);
            if (lv.Items[line].Selected)
            {
                // ----------------------------------------------------------------- selected colors
                bc = Color.FromArgb(49, 106, 197);
                fc = Color.White;
            }
            else
            {
                // ----------------------------------------------------------------- deselected colors
                if (line >= 0)
                {
                    switch (LineType(line))
                    {
                        case "Master":
                            bc = Color.FromArgb(180, 205, 255);
                            //(190, 215, 255)
                            break;
                        case "Slave":
                            bc = Color.FromArgb(255, 200, 160);
                            //(245, 215, 185) '(255, 230, 200)
                            break;
                        case "Pin":
                            if (LineSubType(line) != "Unused")
                            {
                                if (LineDirection(line) == "set")
                                {
                                    bc = Color.FromArgb(245, 245, 215);
                                    //(255, 255, 225)
                                }
                                else
                                {
                                    bc = Color.FromArgb(225, 245, 230);
                                    //(235, 255, 240)
                                }
                            }
                            else
                            {
                                bc = Color.FromArgb(255, 255, 255);
                            }

                            break;
                    }
                    fc = Color.Black;
                }
            }
            lv.Items[line].ForeColor = fc;
            lv.Items[line].BackColor = bc;
        }

        private string LineType(Int32 line)
        {
            if (line < 0) return "";
            return MyListView1.Items[line].SubItems[0].Text.Trim();
        }
        private string LineSubType(Int32 line)
        {
            return MyListView1.Items[line].SubItems[2].Text.Trim();
        }
        private string LineDirection(Int32 line)
        {
            return MyListView1.Items[line].SubItems[3].Text.Trim();
        }

        internal Int32 SelectedLine = -1;
        private void MyListView1_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;

            lock (EventsLock)
            {
                // --------------------------------------------------------- change line colors and update "SelectedLine"
                if (MyListView1.SelectedIndices.Count > 0)
                {
                    SelectedLine = MyListView1.SelectedIndices[0];
                    if (ThereminoSystem.ConfigurationIsValid)
                    {
                        ListView_SetLineColors(MyListView1, SelectedLine);
                    }
                }
                else
                {
                    if (ThereminoSystem.ConfigurationIsValid)
                    {
                        ListView_SetLineColors(MyListView1, SelectedLine);
                    }
                    SelectedLine = -1;
                }
                // --------------------------------------------------------- show line props
                ShowProps();
            }
        }

        private void ShowProps()
        {
            //
            Module_SaveLoad.EventsAreEnabled = false;
            //
            GroupBox_PinProps.Visible = false;
            GroupBox_TouchProps.Visible = false;
            GroupBox_CapSensorProps.Visible = false;
            GroupBox_ServoPwmProps.Visible = false;
            GroupBox_FrequencyProps.Visible = false;
            //
            if (SelectedLine < 0 | SelectedLine > MyListView1.Items.Count - 1)
            {
                GroupBox_MasterProps.Enabled = false;  
            }
            else
            {
                GroupBox_MasterProps.Enabled = true;
                //
                Master m = ThereminoSystem.GetMasterByListLine(SelectedLine, LineType(SelectedLine));
                Pin p = ThereminoSystem.FindPinByListLine(SelectedLine);
                //
                if (!ThereminoSystem.ConfigurationIsValid)
                {
                    GroupBox_MasterProps.Height = 45;
                    if (m != null)
                    {
                        Module_Utils.Combo_Init(cmb_MasterNames, m.GetName());
                    }
                    else
                    {
                        Module_Utils.Combo_Init(cmb_MasterNames, "");
                        GroupBox_MasterProps.Enabled = false;
                    }
                }
                else
                {
                    GroupBox_MasterProps.Height = 130;
                    //
                    switch (LineType(SelectedLine))
                    {
                        case "Master":
                            GroupBox_PinProps.Visible = false;
                            GroupBox_CapSensorProps.Visible = false;
                            GroupBox_ServoPwmProps.Visible = false;
                            break;
                        case "Slave":
                            GroupBox_PinProps.Visible = false;
                            GroupBox_CapSensorProps.Visible = false;
                            GroupBox_ServoPwmProps.Visible = false;
                            break;
                        case "Pin":
                            GroupBox_PinProps.Visible = true;
                            GroupBox_PinProps.Height = txt_ResponseSpeed.Bottom + 10;
                            break;
                    }
                    //
                    if (m != null)
                    {
                        Module_Utils.Combo_Init(cmb_MasterNames, m.GetName());
                        txt_CommSpeed.NumericValueInteger = m.CommSpeed;
                        chk_FastDataExchange.Checked = m.FastComm;

                        if (((m.SlaveCount > 1)
                              || ((m.SlaveCount > 0)
                              && (m.Slaves[0].SlaveType != Slave.SlaveTypes.MasterPins))))
                        {
                            Label_CommSpeed.Enabled = true;
                            txt_CommSpeed.Enabled = true;
                            chk_FastDataExchange.Enabled = true;
                        }
                        else
                        {
                            Label_CommSpeed.Enabled = false;
                            txt_CommSpeed.Enabled = false;
                            txt_CommSpeed.Text = "-";
                            chk_FastDataExchange.Enabled = false;
                        }

                        if (p != null)
                        {
                            Module_Utils.Combo_Init(cmb_PinType, Pin.PinTypeToString(p.GetPinType()));
                            txt_Slot.NumericValue = p.Slot;
                            txt_MaxValue.NumericValue = p.Value_Max;
                            txt_MinValue.NumericValue = p.Value_Min;
                            txt_ResponseSpeed.NumericValueInteger = p.ResponseSpeed;
                            switch (p.GetPinType())
                            {
                                case Pin.PinTypes.UNUSED:
                                    GroupBox_PinProps.Height = cmb_PinType.Bottom + 10;
                                    break;
                                case Pin.PinTypes.SERVO_8:
                                case Pin.PinTypes.SERVO_16:
                                    GroupBox_ServoPwmProps.Text = "Servo properties";
                                    txt_ServoMaxTime.NumericValue = p.MaxTime;
                                    txt_ServoMinTime.NumericValue = p.MinTime;
                                    GroupBox_ServoPwmProps.Location = GroupBox_CapSensorProps.Location;
                                    GroupBox_ServoPwmProps.Height = txt_ServoMinTime.Bottom + 8;
                                    GroupBox_ServoPwmProps.Visible = true;
                                    break;
                                case Pin.PinTypes.PWM_8:
                                case Pin.PinTypes.PWM_16:
                                    GroupBox_ServoPwmProps.Text = "PWM properties";
                                    txt_ServoMaxTime.NumericValue = p.MaxTime;
                                    txt_ServoMinTime.NumericValue = p.MinTime;
                                    chk_LogResponse.Checked = p.LogResponse;
                                    GroupBox_ServoPwmProps.Location = GroupBox_CapSensorProps.Location;
                                    GroupBox_ServoPwmProps.Height = chk_LogResponse.Bottom + 7;
                                    GroupBox_ServoPwmProps.Visible = true;
                                    break;
                                case Pin.PinTypes.CAP_8:
                                case Pin.PinTypes.CAP_16:
                                    GroupBox_TouchProps.Text = "Touch properties";
                                    txt_MinVariation.NumericValue = p.MinVariation;
                                    txt_ProportionalArea.NumericValue = p.ProportionalArea;
                                    GroupBox_TouchProps.Location = GroupBox_CapSensorProps.Location;
                                    GroupBox_TouchProps.Visible = true;
                                    break;
                                case Pin.PinTypes.USOUND_SENSOR:
                                    GroupBox_CapSensorProps.Text = "UltraSound properties";
                                    txt_CapMaxDist.NumericValue = p.MaxDist_mm;
                                    txt_CapMinDist.NumericValue = p.MinDist_mm;
                                    chk_RemoveErrors.Location = Label_Area.Location;
                                    chk_RemoveErrors.Visible = true;
                                    chk_RemoveErrors.Checked = p.RemoveErrors;
                                    Label_Area.Visible = false;
                                    txt_CapArea.Visible = false;
                                    GroupBox_CapSensorProps.Height = txt_CapArea.Bottom + 8;
                                    GroupBox_CapSensorProps.Visible = true;
                                    break;
                                case Pin.PinTypes.CAP_SENSOR:
                                    GroupBox_CapSensorProps.Text = "Cap sensor properties";
                                    txt_CapMaxDist.NumericValue = p.MaxDist_mm;
                                    txt_CapMinDist.NumericValue = p.MinDist_mm;
                                    txt_CapArea.NumericValue = p.Area_cmq;
                                    chk_RemoveErrors.Visible = false;
                                    Label_Area.Visible = true;
                                    txt_CapArea.Visible = true;
                                    GroupBox_CapSensorProps.Height = txt_CapArea.Bottom + 8;
                                    GroupBox_CapSensorProps.Visible = true;
                                    break;
                                case Pin.PinTypes.COUNTER:
                                case Pin.PinTypes.COUNTER_PU:
                                case Pin.PinTypes.FAST_COUNTER:
                                case Pin.PinTypes.FAST_COUNTER_PU:
                                case Pin.PinTypes.PERIOD:
                                case Pin.PinTypes.PERIOD_PU:
                                    GroupBox_FrequencyProps.Text = "Freq. properties";
                                    chk_ConvertToFrequency.Checked = p.ConvertToFreq;
                                    txt_MaxFreq.NumericValue = p.MaxFreq;
                                    txt_MinFreq.NumericValue = p.MinFreq;
                                    if (chk_ConvertToFrequency.Checked)
                                    {
                                        GroupBox_PinProps.Height = txt_ResponseSpeed.Bottom + 10;
                                        GroupBox_FrequencyProps.Height = txt_MinFreq.Bottom + 8;
                                    }
                                    else
                                    {
                                        GroupBox_PinProps.Height = txt_Slot.Bottom + 7;
                                        GroupBox_FrequencyProps.Height = chk_ConvertToFrequency.Bottom + 10;
                                    }

                                    GroupBox_FrequencyProps.Left = GroupBox_PinProps.Left;
                                    GroupBox_FrequencyProps.Top = GroupBox_PinProps.Bottom + 6;
                                    GroupBox_FrequencyProps.Visible = true;
                                    break;
                            }
                        }
                    }
                }
            }
            //
            Module_SaveLoad.EventsAreEnabled = true;
        }










        // ==============================================================================================================
        //  AUTO CALIBRATION
        // ==============================================================================================================

        private void Timer_1Hz_Tick(System.Object eventSender, System.EventArgs eventArgs)
        {
            if (btn_Calibrate.Enabled)
            {
                TestDeltaToRestartCalibrationTime();
                TestCalibrationTime();
                ShowCalibrationRedLine();
            }
        }


        // ==============================================================================================================
        //   AUTO CALIBRATION
        // ==============================================================================================================


        private double CalibrationTime;
        private void TestDeltaToRestartCalibrationTime()
        {
            foreach (Master m in ThereminoSystem.Masters)
            {
                for (Int32 i = 0; i <= m.SlaveCount - 1; i++)
                {
                    UInt32 rd = m.Slaves[i].GetCapSensor_Value_RawInteger_Delta();
                    if (rd > txt_MinChange.NumericValueInteger)
                    {
                        CalibrationTime = 0;
                        ShowCalibrationRedLine();
                    }
                }
            }
        }

        private void TestCalibrationTime()
        {
            if (!Module_SaveLoad.EventsAreEnabled) return;
            CalibrationTime += 0.033;
            if (CalibrationTime > 0.99)
            {
                DoCalibrationAndResetTime();
            }
        }

        private void DoCalibrationAndResetTime()
        {
            CalibrationTime = 0;
            btn_Calibrate.Checked = true;
            btn_Calibrate.Refresh();
            ThereminoSystem.TheSystem_Calibrate();
            Module_Utils.SleepMyThread(100);
            btn_Calibrate.Checked = false;
        }

        private void ShowCalibrationRedLine()
        {
            Module_FillBars.FillPictureBox_Horizontal(Pic_CalibrateTime, CalibrationTime, Color.FromArgb(255, 120, 0), Color.LightGray, 0);
        }

        internal void EnableCalibrateButton(bool enable)
        {
            if (enable)
            {
                CalibrationTime = 0.6; // start with 10 seconds delay
            }
            else
            {
                CalibrationTime = 0;
            }
            ShowCalibrationRedLine();
            btn_Calibrate.Enabled = enable;
            txt_MinChange.Enabled = enable;
        }



        // ==============================================================================================================
        //   ToolTips
        // ==============================================================================================================

        private ToolTip ttp1;
        private void ToolTips_Init()
        {
            ttp1 = new ToolTip();
            ttp1.ShowAlways = true;
            ttp1.UseAnimation = true;
            ttp1.UseFading = true;
            ttp1.IsBalloon = true;
            ttp1.AutoPopDelay = 32700;
            ttp1.InitialDelay = 500;
            ttp1.ReshowDelay = 500;
            // --------------------------------------------------------------- Add here Controls and ToolTip-Text
            ttp1.SetToolTip(txt_CommSpeed, "Communication speed" + 
                                           Constants.vbCrLf + 
                                           "- - - - - - - - - - - - - - -" + 
                                           Constants.vbCrLf + "  1  =     1  Kilo-Baud" + 
                                           Constants.vbCrLf + "  2  =     2  Kilo-Baud" + 
                                           Constants.vbCrLf + "  3  =     5  Kilo-Baud" + 
                                           Constants.vbCrLf + "  4  =   10  Kilo-Baud" + 
                                           Constants.vbCrLf + "  5  =   20  Kilo-Baud" + 
                                           Constants.vbCrLf + "  6  =   50  Kilo-Baud" + 
                                           Constants.vbCrLf + "  7  = 100  Kilo-Baud" + 
                                           Constants.vbCrLf + "  8  = 200  Kilo-Baud" + 
                                           Constants.vbCrLf + "  9  = 500  Kilo-Baud" + 
                                           Constants.vbCrLf + "10  =  1  Mega-Baud" + 
                                           Constants.vbCrLf + "11  =  2  Mega-Baud" + 
                                           Constants.vbCrLf + "12  =  4  Mega-Baud");

            ttp1.SetToolTip(txt_MinChange, "Sensitivity to movements" + 
                                           Constants.vbCrLf + 
                                           " - - - - - - - - - - - - - - - - -" + 
                                           Constants.vbCrLf + " 100 = large movements" + 
                                           Constants.vbCrLf + "   30 = normal" + 
                                           Constants.vbCrLf + "   10 = little movements" +
                                           Constants.vbCrLf + "     0 = autocalibrate disabled");

            ttp1.SetToolTip(txt_CapArea, "Approximate area of the sensor." + 
                                         Constants.vbCrLf + 
                                         " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" + 
                                         Constants.vbCrLf + 
                                         " The linearity between zones \"Away\" and \"Close\" can be altered" + 
                                         Constants.vbCrLf + 
                                         " setting a value-area more or less than the real one." + 
                                         Constants.vbCrLf + 
                                         " A greater value compresses the area more distant from the sensor." + 
                                         Constants.vbCrLf + 
                                         " A smaller value expands the area most distant from the sensor.");
        }

        // --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
        private void txt_Min_MouseEnter(object sender, System.EventArgs e)
        {

        }
        public Form1()
        {
            LocationChanged += Form1_LocationChanged;
            FormClosing += Form1_FormClosing;
            Load += Form1_Load;
            InitializeComponent();
        }
    }
}
