using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
namespace Theremino_HAL
{
	static class Module_FillBars
	{

		// =======================================================================================
		//  CPU USAGE   >>> MUST BE CALLED ONE TIME EVERY SECOND <<<
		// =======================================================================================
		//Private ProcessCpuCounter As PerformanceCounter
		//Private TotalCpuCounter As PerformanceCounter
		//'Private MemoryCounter As PerformanceCounter

		//Friend Sub InitPerformanceCounters()
		//    If ProcessCpuCounter Is Nothing Then ProcessCpuCounter = New PerformanceCounter("Process", "% Processor Time", Process.GetCurrentProcess.ProcessName)
		//    If TotalCpuCounter Is Nothing Then TotalCpuCounter = New PerformanceCounter("Processor", "% Processor Time", "_Total")
		//    'If MemoryCounter Is Nothing Then MemoryCounter = New PerformanceCounter("Memory", "Available MBytes")
		//End Sub

		//Friend Sub ShowPerformanceCounters()
		//    If ProcessCpuCounter IsNot Nothing Then
		//        Dim pcount As Int32 = System.Environment.ProcessorCount
		//        Dim app As Double = ProcessCpuCounter.NextValue / pcount
		//        ProgressBar_ToolStripLabel(Form2.ToolStripLabel1, "App ", app)
		//    End If
		//    If TotalCpuCounter IsNot Nothing Then
		//        Dim sys As Double = TotalCpuCounter.NextValue
		//        ProgressBar_ToolStripLabel(Form2.ToolStripLabel2, "Sys ", sys)
		//    End If
		//End Sub


		// =======================================================================================
		//  CPU TIME MILLISEC   >>> MUST BE CALLED ABOUT 30 TIMES PER SECOND <<<
		// =======================================================================================
		//Private cpuTime_Font As Font
		//Friend Sub ShowCpuTime(ByVal pbox As PictureBox, ByVal timeMicrosec As Double)

		//    If pbox.Image Is Nothing Then
		//        ' -------------------------------------------------------- using a image for best performance
        //        Module_ImageFilters.InitPictureboxImage(pbox)
		//        cpuTime_Font = New Font("Tahoma", pbox.ClientSize.Height - 2, FontStyle.Regular, GraphicsUnit.Pixel)
		//    End If

		//    Static tt As Double = 0
		//    Dim delta As Double
		//    'delta = (TimeMicrosec - tt) / (tt * 0.001 + 1)

		//    delta = (timeMicrosec - tt) * 0.005
		//    delta = Math.Sign(delta) * (Math.Abs(delta) ^ 2)
		//    If delta > 10000 Then delta = 10000
		//    If delta < -10000 Then delta = -10000
		//    tt += delta

		//    ' ----------------------------------------------------------- using "Graphics.FromImage" for best performance
		//    Dim g As Graphics = Graphics.FromImage(pbox.Image)
		//    g.Clear(Color.MintCream)
		//    g.DrawString((tt / 1000).ToString("0.0 mS"), cpuTime_Font, Brushes.Black, 2, 0)

		//    ' ----------------------------------------------------------- final refresh - no flickering
		//    pbox.Refresh()
		//End Sub


		// =======================================================================================
		//  DisplayPictureBoxMarker
		// =======================================================================================
		//Friend Sub DisplayPictureBoxMarker(ByVal pbox As PictureBox, ByVal x As Double, ByVal y As Double)
		//    ' ------------------------------------------------ using a bitmap for best performance
		//    If pbox.Image Is Nothing Then
        //        Module_ImageFilters.InitPictureboxImage(pbox)
		//    End If
		//    ' ------------------------------------------------ using "Graphics.FromImage" for best performance
		//    Dim g As Graphics = Graphics.FromImage(pbox.Image)
		//    Const Diam As Single = 16
		//    Dim px As Single = CSng(x * (pbox.ClientSize.Width - Diam - 1))
		//    Dim py As Single = CSng((1 - y) * (pbox.ClientSize.Height - Diam - 1))
		//    Dim d2 As Single = CSng(Diam / 2)
		//    Dim p As Pen = New Pen(Color.Black, 2)
		//    ' ------------------------------------------------ delete old marker
		//    Static OldPx As Single
		//    Static OldPy As Single
		//    g.FillRectangle(New SolidBrush(Color.AliceBlue), OldPx, OldPy, Diam + 2, Diam + 2)
		//    pbox.Invalidate(New Rectangle(CInt(OldPx), CInt(OldPy), CInt(Diam + 2), CInt(Diam + 2)))
		//    OldPx = px
		//    OldPy = py
		//    ' ------------------------------------------------ draw new marker         
		//    g.DrawLine(p, px, py + d2, px + Diam, py + d2)
		//    g.DrawLine(p, px + d2, py, px + d2, py + Diam)
		//    pbox.Invalidate(New Rectangle(CInt(px), CInt(py), CInt(Diam), CInt(Diam)))
		//End Sub



		// =======================================================================================
		//  DisplayCounterscope
		// =======================================================================================

        static Int32 static_DisplayCounterscope_n = 0;
        static float static_DisplayCounterscope_oldy2 = 0;
        static float static_DisplayCounterscope_oldy1 = 0;

		public static void DisplayCounterscope(PictureBox pbox, Single count1, Single count2, Int32 speed)
		{
			// ------------------------------------------------ remove possible errors
			if (count1 < -1000000) count1 = 0; 
			if (count2 < -1000000) count2 = 0; 
			if (count1 > 1000000) count1 = 0; 
			if (count2 > 1000000) count2 = 0; 
			// ------------------------------------------------ using a bitmap for best performance
			if (pbox.Image == null) 
            {
                Module_ImageFilters.InitPictureboxImage(pbox);
			}
			// ------------------------------------------------ using "Graphics.FromImage" for best performance
			Graphics g = Graphics.FromImage(pbox.Image);
			float px = pbox.Width - 1;
			//
			
			// ------------------------------------------------ draw the scale
            Single d = pbox.ClientSize.Height / 10.1F;
            Single y = 1;
            Pen p1 = new Pen(Color.FromArgb(140, 140, 140));
            Pen p2 = new Pen(Color.FromArgb(210, 210, 210));
			for (Int32 i = 0; i <= 10; i ++) 
            {
				g.DrawLine(p1, px, y, px + 1, y);
                y += d / 2;
                g.DrawLine(p2, px, y, px + 1, y);
                y += d / 2;
			}
            // ------------------------------------------------ draw indicators
            p1 = new Pen(Color.DarkBlue, 2);
            p2 = new Pen(Color.DarkRed, 2);
            float py1 = 2 * count1 + pbox.ClientSize.Height / 2f;
            float py2 = 2 * count2 + pbox.ClientSize.Height / 2f;
            if (Math.Abs(static_DisplayCounterscope_oldy1 - py1) > 1000) static_DisplayCounterscope_oldy1 = py1;
            if (Math.Abs(static_DisplayCounterscope_oldy2 - py2) > 1000) static_DisplayCounterscope_oldy2 = py2; 
            g.DrawLine(p1, px - 1, static_DisplayCounterscope_oldy1, px, py1);
            g.DrawLine(p2, px - 1, static_DisplayCounterscope_oldy2, px, py2);
            static_DisplayCounterscope_oldy1 = py1;
            static_DisplayCounterscope_oldy2 = py2;
            // ------------------------------------------------ scroll
            static_DisplayCounterscope_n += speed;
            if (static_DisplayCounterscope_n > 100)
            {
                static_DisplayCounterscope_n -= 100;
                //Module_ImageFilters.ImageScrollInPlace(pbox.Image, -1, 0, 0);
                Module_ImageFilters.PictureScrollInPlace(pbox, -1, 0, 0);
                //pbox.Refresh()
                pbox.Invalidate();
            }
		}


		// =======================================================================================
		//  FILL PICTURE BOX - WITH SINGLE COLOR
		// =======================================================================================
		public static void FillPictureBox(PictureBox pbox, 
                                            double value, 
                                            Color c1, 
                                            Color c2, 
                                            double MarkPoint)
		{
			// ------------------------------------------------------- using a bitmap for best performance
			if (pbox.Image == null) 
            {
                Module_ImageFilters.InitPictureboxImage(pbox);
			}
			// -------------------------------------------------------
			if (double.IsNaN(value)) value = 0; 
			if (value < 0) value = 0; 
			if (value > 1) value = 1; 
			Int32 v = (int)(value * pbox.Width);
			// ------------------------------------------------------- using "Graphics.FromImage" for best performance
			Graphics g = Graphics.FromImage(pbox.Image);
			g.FillRectangle(new SolidBrush(c1), 0, 0, v, pbox.ClientSize.Height);
			g.FillRectangle(new SolidBrush(c2), v, 0, pbox.ClientSize.Width - v, pbox.ClientSize.Height);
			//
			//Dim f As Font = New Font("Tahoma", pbox.ClientSize.Height - 2, FontStyle.Regular, GraphicsUnit.Pixel)
			//g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit
			//g.DrawString(Str(Int(value * 100)) & " %", f, Brushes.Black, CInt(pbox.Width / 2 - 17), 0)

			if (MarkPoint > 0) 
            {
				v = (int)(MarkPoint * pbox.Width);
				g.DrawLine(Pens.Black, v, 0, v, pbox.ClientSize.Height);
			}

			// ------------------------------------------------------- final refresh - no flickering
			pbox.Refresh();
		}

        public static void FillPictureBox_Horizontal(PictureBox pbox, double value, Color c1, Color c2, double MarkPoint)
		{
			// ------------------------------------------------------- using a bitmap for best performance
			if (pbox.Image == null) 
            {
                Module_ImageFilters.InitPictureboxImage(pbox);
			}
			// -------------------------------------------------------
			if (double.IsNaN(value)) value = 0; 
			if (value < 0) value = 0; 
			if (value > 1) value = 1;
            Int32 v = (int)(value * pbox.Width);
			// ------------------------------------------------------- using "Graphics.FromImage" for best performance
            Graphics g = Graphics.FromImage(pbox.Image);

            g.FillRectangle(new SolidBrush(c1), 0, 0, v, pbox.Height);
            g.FillRectangle(new SolidBrush(c2), v, 0, pbox.ClientSize.Width - v, pbox.ClientSize.Height);
			//
			// ------------------------------------------------------- final refresh - no flickering
            pbox.Refresh();
		}



		// =======================================================================================
		//  FILL BARS - WITH GRADIENT
		// =======================================================================================
		//Private Sub ProgressBar_Cpu(ByVal pbox As PictureBox, ByVal PercentualCPU As Double)
		//    '
		//    If pbox.Image Is Nothing Then
        //        Module_ImageFilters.InitPictureboxImage(pbox)
		//    End If
		//    '
		//    If PercentualCPU < 0 Then PercentualCPU = 0
		//    If PercentualCPU > 100 Then PercentualCPU = 100
		//    '
		//    Dim r As Rectangle
		//    r.X = 0
		//    r.Y = 0
		//    r.Width = CInt(pbox.Width / 2) - 1   ' <--- (-1) to correct the vertical green line in the middle
		//    r.Height = pbox.Height
		//    Dim b1 As Drawing2D.LinearGradientBrush = New Drawing2D.LinearGradientBrush(r, _
		//                                                                        Color.FromArgb(100, 255, 0), _
		//                                                                        Color.FromArgb(255, 200, 0), _
		//                                                                        Drawing2D.LinearGradientMode.Horizontal)
		//    Dim b2 As Drawing2D.LinearGradientBrush = New Drawing2D.LinearGradientBrush(r, _
		//                                                                        Color.FromArgb(255, 200, 0), _
		//                                                                        Color.FromArgb(255, 0, 0), _
		//                                                                        Drawing2D.LinearGradientMode.Horizontal)
		//    '
		//    Dim v As Int32 = CInt((PercentualCPU * pbox.Width) / 100)
		//    Dim vmid As Int32 = CInt(pbox.Width / 2)
		//    '
		//    ' ----------------------------------------------------------- using "Graphics.FromImage" for best performance
		//    Dim g As Graphics = Graphics.FromImage(pbox.Image)

		//    If PercentualCPU <= 50 Then
		//        g.FillRectangle(b1, 0, 0, v, pbox.ClientSize.Height)
		//    Else
		//        g.FillRectangle(b1, 0, 0, vmid, pbox.ClientSize.Height)
		//        g.FillRectangle(b2, vmid, 0, v - vmid, pbox.ClientSize.Height)
		//    End If
		//    Dim b As Brush = New SolidBrush(pbox.BackColor)
		//    g.FillRectangle(b, v, 0, pbox.ClientSize.Width - v, pbox.ClientSize.Height)
		//    '
		//    Dim f As Font = New Font("Tahoma", pbox.ClientSize.Height - 2, FontStyle.Regular, GraphicsUnit.Pixel)
		//    g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit
		//    g.DrawString(Str(Int(PercentualCPU)) & "%", f, Brushes.Black, CInt(pbox.Width / 2 - 17), 0)
		//    '
		//    ' ----------------------------------------------------------- final refresh - no flickering
		//    pbox.Refresh()
		//End Sub


		// =======================================================================================
		//  ProgressBar_ToolStripLabel
		// =======================================================================================
		//Private Sub ProgressBar_ToolStripLabel(ByRef lbl As ToolStripLabel, ByVal text As String, ByVal Percentual As Double)

		//    'Percentual *= 4

		//    Dim w As Int32 = lbl.Width
		//    Dim h As Int32 = lbl.Height

		//    If lbl.Image Is Nothing Then
		//        lbl.Image = New Bitmap(w, h)
		//    End If

		//    If Percentual < 0 Then Percentual = 0
		//    If Percentual > 100 Then Percentual = 100
		//    '
		//    Dim r As Rectangle
		//    r.X = 0
		//    r.Y = 0
		//    r.Width = CInt(w / 2) - CInt((w / 2) Mod 2)   ' <--- (-1) to correct the vertical green line in the middle
		//    r.Height = h
		//    Dim b1 As Drawing2D.LinearGradientBrush = New Drawing2D.LinearGradientBrush(r, _
		//                                                                        Color.FromArgb(120, 160, 0), _
		//                                                                        Color.FromArgb(255, 200, 0), _
		//                                                                        Drawing2D.LinearGradientMode.Horizontal)
		//    Dim b2 As Drawing2D.LinearGradientBrush = New Drawing2D.LinearGradientBrush(r, _
		//                                                                        Color.FromArgb(255, 200, 0), _
		//                                                                        Color.FromArgb(255, 0, 0), _
		//                                                                        Drawing2D.LinearGradientMode.Horizontal)
		//    '
		//    Dim v As Int32 = CInt((Percentual * w) / 100) + 1
		//    Dim vmid As Int32 = CInt(w / 2)

		//    ' ----------------------------------------------------------- using "Graphics.FromImage" for best performance
		//    Dim g As Graphics = Graphics.FromImage(lbl.Image)

		//    If Percentual <= 50 Then
		//        g.FillRectangle(b1, 1, 1, v, 4)
		//    Else
		//        g.FillRectangle(b1, 1, 1, vmid, 4)
		//        g.FillRectangle(b2, vmid, 1, v - vmid, 4)
		//    End If
		//    Dim b As Brush = New SolidBrush(Color.FromArgb(160, 200, 240))
		//    g.FillRectangle(b, v, 1, w - v, 4)

		//    g.DrawLine(Pens.Gray, v, 1, v, 4)
		//    g.DrawRectangle(Pens.CadetBlue, 1, 0, w - 2, 5)
		//    '
		//    ' ----------------------------------------------------------- final refresh - no flickering
		//    Dim s As String = Percentual.ToString("0")
		//    If s.Length < 2 Then s = " " & s
		//    lbl.Text = text & s & " %"
		//    lbl.Invalidate()
		//End Sub



	}
}
