﻿using System;
using System.Windows.Forms;

namespace Theremino_HAL
{
    static class Utils_LocaleNames
    {
        internal static string Language = "English";
        private static string[,] ls = new string [1,0];

        internal static void SetLocales()
        {
            //  ------------------------------------- read the file
            ReadLocaleFile();
            //  ------------------------------------- rename
            RenameControls(My.MyProject.Forms.Form1);
            RenameControls(My.MyProject.Forms.Form2);
            //  ------------------------------------- release the array
            Module_Utils.RedimPreserve_2D_Array(ref ls, -1, -1);
        }

        private static void ReadLocaleFile()
        {
            string locfilename = Module_SaveLoad.PlatformAdjustedFileName(Application.StartupPath + "\\Docs\\Language_" + Language.Substring(0, 3) + ".txt",  "");
            if (!Module_SaveLoad.FileExists(locfilename))
            {
                locfilename = Module_SaveLoad.PlatformAdjustedFileName(Application.StartupPath + "\\Docs\\Language_ENG.txt", "");
            }
            if (Module_SaveLoad.FileExists(locfilename))
            {
                Int32 i = -1;
                string s0;
                string s1;
                // 
                System.IO.StreamReader f;
                f = new System.IO.StreamReader(locfilename, System.Text.Encoding.Default);
                //
				while (!f.EndOfStream) 
                {
                    s1 = f.ReadLine();
                    s1 = s1.Replace('\t', ' ').Trim();
                    s0 = Module_SaveLoad.ExtractParamName(ref s1);
                    if (((s0.Length > 1) && (s1.Length > 1)))
                    {
                        i++;
                        //ls = ResizeArray(ls, 2, i+1);
                        Module_Utils.RedimPreserve_2D_Array(ref ls, 1, i);
                        ls[0, i] = s0;
                        ls[1, i] = s1;
                    }
                }
                f.Close();
            }
        }

        private static void RenameControls(Control container)
        {
            // 
            for (Int32 i = 0; (i <= (ls.GetLength(1) - 1)); i++)
            {
                if ((container.Name == ls[0, i]))
                {
                    container.Text = ls[1, i];
                }
            }
            // 
            foreach (Control ctrl in container.Controls)
            {
                for (Int32 i = 0; (i <= (ls.GetLength(1) - 1)); i++)
                {
                    if ((ctrl.Name == ls[0, i]))
                    {
                        ctrl.Text = ls[1, i];
                    }
                    if (ctrl is ToolStrip)
                    {
                        ToolStrip ts = (ToolStrip)ctrl;
                        RenameToolStripItems(ref ts);
                    }
                    if (ctrl is MenuStrip)
                    {
                        MenuStrip ms = (MenuStrip)ctrl;
                        RenameMenuStripItems(ref ms);
                    }
                }
                //  ---------------------------- Recursively call this function for any container controls.
                if (container.HasChildren)
                {
                    RenameControls(ctrl);
                }
            }
        }

        private static void RenameToolStripItems(ref ToolStrip ts)
        {
            for (Int32 i = 0; (i <= (ls.GetLength(1) - 1)); i++)
            {
                for (Int32 j = 0; (j <= (ts.Items.Count - 1)); j++)
                {
                    if ((ts.Items[j].Name == ls[0, i]))
                    {
                        ts.Items[j].Text = (" " + ls[1, i]);
                    }
                }
            }
        }

        private static void RenameMenuStripItems(ref MenuStrip ms)
        {
            for (Int32 i = 0; (i <= (ls.GetLength(1) - 1)); i++)
            {
                for (Int32 j = 0; (j <= (ms.Items.Count - 1)); j++)
                {
                    if ((ms.Items[j].Name == ls[0, i]))
                    {
                        ms.Items[j].Text = (" " + ls[1, i]);
                    }
                    ToolStripMenuItem tsmi = (ToolStripMenuItem)ms.Items[j];
                    for (Int32 k = 0; (k <= (tsmi.DropDownItems.Count - 1)); k++)
                    {
                        if ((tsmi.DropDownItems[k].Name == ls[0, i]))
                        {
                            tsmi.DropDownItems[k].Text = (" " + ls[1, i]);
                        }
                    }
                }
            }
        }
    }
}

